--[[
	Cooldown Timeline, Vreenak (US-Remulos)
	https://www.curseforge.com/wow/addons/cooldown-timeline
	
	Update notes:
		- Almost complete re-write, see changelog in game for details
]]--


CDTL2 = LibStub("AceAddon-3.0"):NewAddon("CDTL2", "AceConsole-3.0", "AceEvent-3.0")
CDTL2.Masque = LibStub("Masque", true)
CDTL2.LSM = LibStub("LibSharedMedia-3.0")

CDTL2.version = "2.5.4-1b2"
CDTL2.cdUID = 999
CDTL2.lanes = {}
CDTL2.barFrames = {}
CDTL2.readyFrames = {}
CDTL2.holders = {}
CDTL2.offensives = {}
CDTL2.player = {}
CDTL2.cooldowns = {}
CDTL2.spellData = {}
CDTL2.colors = {
	bg = {},
	db = { r = 0.1, g = 0.1, b = 0.1, a = 0.75 },
}

local private = {}

local defaults = {
    profile = {
		global = {
			firstRun = true,
			previousVersion = "2.5.4-1",
			
			--advancedOptions = false,
			unlockFrames = true,
			debugMode = false,
			
			autohide = false,
			enableTooltip = false,
			
			spells = {
				enabled = true,
				showByDefault = true,
				defaultLane = 1,
				defaultReady = 1,
				defaultBar = 1,
			},
			
			items = {
				enabled = true,
				showByDefault = true,
				defaultLane = 1,
				defaultReady = 1,
				defaultBar = 1,
			},
			
			buffs = {
				enabled = true,
				showByDefault = true,
				defaultLane = 2,
				defaultReady = 2,
				defaultBar = 2,
			},
			
			debuffs = {
				enabled = true,
				showByDefault = true,
				defaultLane = 3,
				defaultReady = 3,
				defaultBar = 3,
			},
			
			offensives = {
				enabled = true,
				showByDefault = true,
				defaultLane = 0,
				defaultReady = 0,
				defaultBar = 0,
			},
			
			petSpells = {
				enabled = true,
				showByDefault = true,
				defaultLane = 1,
				defaultReady = 1,
				defaultBar = 1,
			},
			
			zoom = 1,			
		},
	
		lanes = {	
			lane1 = {
				enabled = true,
				name = "Lane 1",
				
				posX = 0,
				posY = -250,
				width = 400,
				height = 44,
				relativeTo = "CENTER",
				
				tracking = {
					primaryTracking = "NONE",
					secondaryTracking = "GCD",
					
					stTexture = "CDTL2 Smooth",
					stTextureColor = { r = 1, g = 1, b = 1, a = 0.5 },
					
					stHeight = 44,
					stWidth = 5,
				},
				
				stacking = {
					enabled = false,
					raiseOnMouseOver = false,
					style = "GROUPED",
					grow = "UP",
					height = 80,
				},
				
				fgTexture = "CDTL2 Smooth",
				fgTextureColor = { r = 0.77647, g = 0.11765, b = 0.28235, a = 1 },
				bgTexture = "CDTL2 Smooth",
				bgTextureColor = { r = 0.15, g = 0.15, b = 0.15, a = 0.5 },
				
				border = {
					style = "CDTL2 Shadow",
					color = { r = 0, g = 0, b = 0, a = 0.25 },
					size = 5,
					padding = 5,
					inset = 0,
				},
				
				icons = {
					size = 40,
					hlStyle = "NONE",
					
					border = {
						style = "None",
						color = { r = 0, g = 0, b = 0, a = 1 },
						size = 5,
						padding = 5,
						inset = 0,
					},
					
					hlBorder = {
						style = "None",
						color = { r = 0, g = 1, b = 0, a = 1 },
						size = 5,
						padding = 5,
						inset = 0,
					},
					
					text1 = {
						enabled = true,
						used = true,
						edit = false,
						text = "[cd.stacks]",
						font = "Fira Sans Condensed",
						size = 11,
						color = { r = 1, g = 1, b = 1, a = 1 },
						align = "LEFT",
						anchor = "TOPLEFT",
						offX = 2,
						offY = -7,
						outline = "OUTLINE",
						shadColor = { r = 0, g = 0, b = 0, a = 0.5 },
						shadX = 1.5,
						shadY = -1,
					},
					text2 = {
						enabled = true,
						used = true,
						edit = false,
						text = "[cd.time]",
						font = "Fira Sans Condensed",
						size = 16,
						color = { r = 1, g = 1, b = 1, a = 1 },
						align = "CENTER",
						anchor = "CENTER",
						offX = 0,
						offY = 0,
						outline = "OUTLINE",
						shadColor = { r = 0, g = 0, b = 0, a = 0.5 },
						shadX = 1.5,
						shadY = -1,
					},
					text3 = {
						enabled = true,
						used = true,
						edit = false,
						text = "",
						font = "Fira Sans Condensed",
						size = 11,
						color = { r = 1, g = 1, b = 1, a = 1 },
						align = "CENTER",
						anchor = "BOTTOM",
						offX = 2,
						offY = 5,
						outline = "OUTLINE",
						shadColor = { r = 0, g = 0, b = 0, a = 0.5 },
						shadX = 1.5,
						shadY = -1,
					},
				},
				
				mode = {
					type = "LINEAR",
					linear = {
						max = 120,
						hideTimeSurplus = true,
					},
					linearAbs = {
						max = 120,
						hideTimeSurplus = true,
					},
					split = {
						max = 120,
						hideTimeSurplus = true,
						count = 2,
						s1v = 10,
						s1p = 0.33,
						s2v = 33,
						s2p = 0.66,
						s3v = 66,
						s3p = 0.75,
					},
					splitAbs = {
						max = 120,
						hideTimeSurplus = true,
						count = 3,
						s1v = 10,
						s1p = 0.25,
						s2v = 30,
						s2p = 0.5,
						s3v = 60,
						s3p = 0.75,
					},
				},
				
				modeText = {
					text1 = {
						enabled = true,
						used = true,
						edit = false,
						text = "T1",
						font = "Fira Sans Condensed",
						size = 12,
						color = { r = 1, g = 1, b = 1, a = 1 },
						align = "LEFT",
						anchor = "LEFT",
						pos = 0,
						offX = 5,
						offY = 0,
						outline = "NONE",
						shadColor = { r = 0, g = 0, b = 0, a = 1 },
						shadX = 1.5,
						shadY = -1,
					},
					text2 = {
						enabled = true,
						used = true,
						text = "T2",
						font = "Fira Sans Condensed",
						size = 12,
						color = { r = 1, g = 1, b = 1, a = 1 },
						align = "CENTER",
						anchor = "LEFT",
						pos = 0.25,
						offX = 0,
						offY = 0,
						outline = "NONE",
						shadColor = { r = 0, g = 0, b = 0, a = 1 },
						shadX = 1.5,
						shadY = -1,
					},
					text3 = {
						enabled = true,
						used = true,
						text = "T3",
						font = "Fira Sans Condensed",
						size = 12,
						color = { r = 1, g = 1, b = 1, a = 1 },
						align = "CENTER",
						anchor = "LEFT",
						pos = 0.5,
						offX = 0,
						offY = 0,
						outline = "NONE",
						shadColor = { r = 0, g = 0, b = 0, a = 1 },
						shadX = 1.5,
						shadY = -1,
					},
					text4 = {
						enabled = true,
						used = true,
						text = "T4",
						font = "Fira Sans Condensed",
						size = 12,
						color = { r = 1, g = 1, b = 1, a = 1 },
						align = "CENTER",
						anchor = "LEFT",
						pos = 0.75,
						offX = 0,
						offY = 0,
						outline = "NONE",
						shadColor = { r = 0, g = 0, b = 0, a = 1 },
						shadX = 1.5,
						shadY = -1,
					},
					text5 = {
						enabled = true,
						used = true,
						text = "T5",
						font = "Fira Sans Condensed",
						size = 12,
						color = { r = 1, g = 1, b = 1, a = 1 },
						align = "RIGHT",
						anchor = "LEFT",
						pos = 1,
						offX = -5,
						offY = 0,
						outline = "NONE",
						shadColor = { r = 0, g = 0, b = 0, a = 1 },
						shadX = 1.5,
						shadY = -1,
					},
				},
				customText = {				
					text1 = {
						enabled = false,
						used = true,
						edit = false,
						text = "Custom Text 1",
						font = "Fira Sans Condensed",
						size = 12,
						color = { r = 1, g = 1, b = 1, a = 1 },
						align = "CENTER",
						anchor = "TOPLEFT",
						pos = 0,
						offX = 0,
						offY = 0,
						outline = "NONE",
						shadColor = { r = 0, g = 0, b = 0, a = 1 },
						shadX = 1.5,
						shadY = -1,
					},
					text2 = {
						enabled = false,
						used = true,
						edit = false,
						text = "Custom Text 2",
						font = "Fira Sans Condensed",
						size = 12,
						color = { r = 1, g = 1, b = 1, a = 1 },
						align = "CENTER",
						anchor = "TOPRIGHT",
						pos = 0,
						offX = 0,
						offY = 0,
						outline = "NONE",
						shadColor = { r = 0, g = 0, b = 0, a = 1 },
						shadX = 1.5,
						shadY = -1,
					},
					text3 = {
						enabled = false,
						used = true,
						edit = false,
						text = "Custom Text 3",
						font = "Fira Sans Condensed",
						size = 12,
						color = { r = 1, g = 1, b = 1, a = 1 },
						align = "CENTER",
						anchor = "CENTER",
						pos = 0,
						offX = 0,
						offY = 0,
						outline = "NONE",
						shadColor = { r = 0, g = 0, b = 0, a = 1 },
						shadX = 1.5,
						shadY = -1,
					},
					text4 = {
						enabled = false,
						used = true,
						edit = false,
						text = "Custom Text 4",
						font = "Fira Sans Condensed",
						size = 12,
						color = { r = 1, g = 1, b = 1, a = 1 },
						align = "CENTER",
						anchor = "BOTTOMLEFT",
						pos = 0,
						offX = 0,
						offY = 0,
						outline = "NONE",
						shadColor = { r = 0, g = 0, b = 0, a = 1 },
						shadX = 1.5,
						shadY = -1,
					},
					text5 = {
						enabled = false,
						used = true,
						edit = false,
						text = "Custom Text 5",
						font = "Fira Sans Condensed",
						size = 12,
						color = { r = 1, g = 1, b = 1, a = 1 },
						align = "CENTER",
						anchor = "BOTTOMRIGHT",
						pos = 0,
						offX = 0,
						offY = 0,
						outline = "NONE",
						shadColor = { r = 0, g = 0, b = 0, a = 1 },
						shadX = 1.5,
						shadY = -1,
					},
				},
			},
			lane2 = {
				enabled = true,
				name = "Lane 2",
				
				posX = 0,
				posY = -200,
				width = 400,
				height = 5,
				relativeTo = "CENTER",
				
				tracking = {
					primaryTracking = "NONE",
					secondaryTracking = "NONE",
					
					stTexture = "CDTL2 Smooth",
					stTextureColor = { r = 1, g = 1, b = 1, a = 0.5 },
					
					stHeight = 30,
					stWidth = 5,
				},
				
				stacking = {
					enabled = false,
					raiseOnMouseOver = false,
					style = "GROUPED",
					grow = "UP",
					height = 80,
				},
				
				fgTexture = "CDTL2 Smooth",
				fgTextureColor = { r = 0.52941, g = 0.77647, b = 0.24314, a = 1 },
				bgTexture = "CDTL2 Smooth",
				bgTextureColor = { r = 0.15, g = 0.15, b = 0.15, a = 0.5 },
				
				border = {
					style = "CDTL2 Shadow",
					color = { r = 0, g = 0, b = 0, a = 0.25 },
					size = 5,
					padding = 5,
					inset = 0,
				},
				
				icons = {
					size = 30,
					hlStyle = "NONE",
					
					border = {
						style = "None",
						color = { r = 0, g = 0, b = 0, a = 1 },
						size = 5,
						padding = 5,
						inset = 0,
					},
					
					hlBorder = {
						style = "None",
						color = { r = 1, g = 1, b = 1, a = 1 },
						size = 5,
						padding = 5,
						inset = 0,
					},
					
					text1 = {
						enabled = true,
						used = true,
						edit = false,
						text = "[cd.stacks]",
						font = "Fira Sans Condensed",
						size = 10,
						color = { r = 1, g = 1, b = 1, a = 1 },
						align = "LEFT",
						anchor = "TOPLEFT",
						offX = 0,
						offY = -5,
						outline = "OUTLINE",
						shadColor = { r = 0, g = 0, b = 0, a = 0.5 },
						shadX = 1.5,
						shadY = -1,
					},
					text2 = {
						enabled = true,
						used = true,
						edit = false,
						text = "[cd.time]",
						font = "Fira Sans Condensed",
						size = 13,
						color = { r = 1, g = 1, b = 1, a = 1 },
						align = "CENTER",
						anchor = "CENTER",
						offX = 0,
						offY = 0,
						outline = "OUTLINE",
						shadColor = { r = 0, g = 0, b = 0, a = 0.5 },
						shadX = 1.5,
						shadY = -1,
					},
					text3 = {
						enabled = true,
						used = true,
						edit = false,
						text = "",
						font = "Fira Sans Condensed",
						size = 10,
						color = { r = 1, g = 1, b = 1, a = 1 },
						align = "RIGHT",
						anchor = "BOTTOMRIGHT",
						offX = 0,
						offY = 5,
						outline = "OUTLINE",
						shadColor = { r = 0, g = 0, b = 0, a = 0.5 },
						shadX = 1.5,
						shadY = -1,
					},
				},
				
				mode = {
					type = "LINEAR",
					linear = {
						max = 120,
						hideTimeSurplus = true,
					},
					linearAbs = {
						max = 120,
						hideTimeSurplus = true,
					},
					split = {
						max = 120,
						hideTimeSurplus = true,
						count = 3,
						s1v = 10,
						s1p = 0.25,
						s2v = 25,
						s2p = 0.5,
						s3v = 50,
						s3p = 0.75,
					},
					splitAbs = {
						count = 3,
						s1v = 10,
						s1p = 0.25,
						s2v = 30,
						s2p = 0.5,
						s3v = 60,
						s3p = 0.75,
						max = 120,
						hideTimeSurplus = true,
					},
				},
				
				modeText = {
					text1 = {
						enabled = false,
						used = true,
						text = "T1",
						font = "Fira Sans Condensed",
						size = 12,
						color = { r = 1, g = 1, b = 1, a = 1 },
						align = "LEFT",
						anchor = "LEFT",
						pos = 0,
						offX = 5,
						offY = 0,
						outline = "NONE",
						shadColor = { r = 0, g = 0, b = 0, a = 1 },
						shadX = 1.5,
						shadY = -1,
					},
					text2 = {
						enabled = false,
						used = true,
						text = "T2",
						font = "Fira Sans Condensed",
						size = 12,
						color = { r = 1, g = 1, b = 1, a = 1 },
						align = "CENTER",
						anchor = "LEFT",
						pos = 0.25,
						offX = 0,
						offY = 0,
						outline = "NONE",
						shadColor = { r = 0, g = 0, b = 0, a = 1 },
						shadX = 1.5,
						shadY = -1,
					},
					text3 = {
						enabled = false,
						used = true,
						text = "T3",
						font = "Fira Sans Condensed",
						size = 12,
						color = { r = 1, g = 1, b = 1, a = 1 },
						align = "CENTER",
						anchor = "LEFT",
						pos = 0.5,
						offX = 0,
						offY = 0,
						outline = "NONE",
						shadColor = { r = 0, g = 0, b = 0, a = 1 },
						shadX = 1.5,
						shadY = -1,
					},
					text4 = {
						enabled = false,
						used = true,
						text = "T4",
						font = "Fira Sans Condensed",
						size = 12,
						color = { r = 1, g = 1, b = 1, a = 1 },
						align = "CENTER",
						anchor = "LEFT",
						pos = 0.75,
						offX = 0,
						offY = 0,
						outline = "NONE",
						shadColor = { r = 0, g = 0, b = 0, a = 1 },
						shadX = 1.5,
						shadY = -1,
					},
					text5 = {
						enabled = false,
						used = true,
						text = "T5",
						font = "Fira Sans Condensed",
						size = 12,
						color = { r = 1, g = 1, b = 1, a = 1 },
						align = "RIGHT",
						anchor = "LEFT",
						pos = 1,
						offX = -5,
						offY = 0,
						outline = "NONE",
						shadColor = { r = 0, g = 0, b = 0, a = 1 },
						shadX = 1.5,
						shadY = -1,
					},
				},
				customText = {				
					text1 = {
						enabled = false,
						used = true,
						edit = false,
						text = "Custom Text 1",
						font = "Fira Sans Condensed",
						size = 12,
						color = { r = 1, g = 1, b = 1, a = 1 },
						align = "CENTER",
						anchor = "TOPLEFT",
						pos = 0,
						offX = 0,
						offY = 0,
						outline = "NONE",
						shadColor = { r = 0, g = 0, b = 0, a = 1 },
						shadX = 1.5,
						shadY = -1,
					},
					text2 = {
						enabled = false,
						used = true,
						edit = false,
						text = "Custom Text 2",
						font = "Fira Sans Condensed",
						size = 12,
						color = { r = 1, g = 1, b = 1, a = 1 },
						align = "CENTER",
						anchor = "TOPRIGHT",
						pos = 0,
						offX = 0,
						offY = 0,
						outline = "NONE",
						shadColor = { r = 0, g = 0, b = 0, a = 1 },
						shadX = 1.5,
						shadY = -1,
					},
					text3 = {
						enabled = false,
						used = true,
						edit = false,
						text = "Custom Text 3",
						font = "Fira Sans Condensed",
						size = 12,
						color = { r = 1, g = 1, b = 1, a = 1 },
						align = "CENTER",
						anchor = "CENTER",
						pos = 0,
						offX = 0,
						offY = 0,
						outline = "NONE",
						shadColor = { r = 0, g = 0, b = 0, a = 1 },
						shadX = 1.5,
						shadY = -1,
					},
					text4 = {
						enabled = false,
						used = true,
						edit = false,
						text = "Custom Text 4",
						font = "Fira Sans Condensed",
						size = 12,
						color = { r = 1, g = 1, b = 1, a = 1 },
						align = "CENTER",
						anchor = "BOTTOMLEFT",
						pos = 0,
						offX = 0,
						offY = 0,
						outline = "NONE",
						shadColor = { r = 0, g = 0, b = 0, a = 1 },
						shadX = 1.5,
						shadY = -1,
					},
					text5 = {
						enabled = false,
						used = true,
						edit = false,
						text = "Custom Text 5",
						font = "Fira Sans Condensed",
						size = 12,
						color = { r = 1, g = 1, b = 1, a = 1 },
						align = "CENTER",
						anchor = "BOTTOMRIGHT",
						pos = 0,
						offX = 0,
						offY = 0,
						outline = "NONE",
						shadColor = { r = 0, g = 0, b = 0, a = 1 },
						shadX = 1.5,
						shadY = -1,
					},
				},
			},
			lane3 = {
				enabled = true,
				name = "Lane 3",
				
				posX = 0,
				posY = -160,
				width = 400,
				height = 5,
				relativeTo = "CENTER",
				
				tracking = {
					primaryTracking = "NONE",
					secondaryTracking = "NONE",
					
					stTexture = "CDTL2 Smooth",
					stTextureColor = { r = 1, g = 1, b = 1, a = 0.5 },
					
					stHeight = 20,
					stWidth = 5,
				},
				
				stacking = {
					enabled = false,
					raiseOnMouseOver = false,
					style = "GROUPED",
					grow = "UP",
					height = 80,
				},
				
				fgTexture = "CDTL2 Smooth",
				fgTextureColor = { r = 0.15294, g = 0.63922, b = 0.77647, a = 1 },
				bgTexture = "CDTL2 Smooth",
				bgTextureColor = { r = 0.15, g = 0.15, b = 0.15, a = 0.5 },
				
				border = {
					style = "CDTL2 Shadow",
					color = { r = 0, g = 0, b = 0, a = 0.25 },
					size = 5,
					padding = 5,
					inset = 0,
				},
				
				icons = {
					size = 30,
					hlStyle = "NONE",
					
					border = {
						style = "None",
						color = { r = 0, g = 0, b = 0, a = 1 },
						size = 5,
						padding = 5,
						inset = 0,
					},
					
					hlBorder = {
						style = "None",
						color = { r = 1, g = 1, b = 1, a = 1 },
						size = 5,
						padding = 5,
						inset = 0,
					},
					
					text1 = {
						enabled = true,
						used = true,
						edit = false,
						text = "[cd.stacks]",
						font = "Fira Sans Condensed",
						size = 10,
						color = { r = 1, g = 1, b = 1, a = 1 },
						align = "LEFT",
						anchor = "TOPLEFT",
						offX = 0,
						offY = -3,
						outline = "OUTLINE",
						shadColor = { r = 0, g = 0, b = 0, a = 0.5 },
						shadX = 1.5,
						shadY = -1,
					},
					text2 = {
						enabled = true,
						used = true,
						edit = false,
						text = "[cd.time]",
						font = "Fira Sans Condensed",
						size = 13,
						color = { r = 1, g = 1, b = 1, a = 1 },
						align = "CENTER",
						anchor = "CENTER",
						offX = 0,
						offY = 0,
						outline = "OUTLINE",
						shadColor = { r = 0, g = 0, b = 0, a = 0.5 },
						shadX = 1.5,
						shadY = -1,
					},
					text3 = {
						enabled = true,
						used = true,
						edit = false,
						text = "",
						font = "Fira Sans Condensed",
						size = 10,
						color = { r = 1, g = 1, b = 1, a = 1 },
						align = "CENTER",
						anchor = "BOTTOMRIGHT",
						offX = -10,
						offY = 0,
						outline = "OUTLINE",
						shadColor = { r = 0, g = 0, b = 0, a = 0.5 },
						shadX = 1.5,
						shadY = -1,
					},
				},
				
				mode = {
					type = "LINEAR",
					linear = {
						max = 120,
						hideTimeSurplus = true,						
					},
					linearAbs = {
						max = 120,
						hideTimeSurplus = true,
					},
					split = {
						max = 120,
						hideTimeSurplus = true,
						count = 3,
						s1v = 5,
						s1p = 0.25,
						s2v = 25,
						s2p = 0.5,
						s3v = 50,
						s3p = 0.75,
					},
					splitAbs = {
						count = 3,
						s1v = 10,
						s1p = 0.25,
						s2v = 30,
						s2p = 0.5,
						s3v = 60,
						s3p = 0.75,
						max = 120,
						hideTimeSurplus = true,
					},
				},
				
				modeText = {
					text1 = {
						enabled = false,
						used = true,
						text = "T1",
						font = "Fira Sans Condensed",
						size = 12,
						color = { r = 1, g = 1, b = 1, a = 1 },
						align = "LEFT",
						anchor = "LEFT",
						pos = 0,
						offX = 5,
						offY = 0,
						outline = "NONE",
						shadColor = { r = 0, g = 0, b = 0, a = 1 },
						shadX = 1.5,
						shadY = -1,
					},
					text2 = {
						enabled = false,
						used = true,
						text = "T2",
						font = "Fira Sans Condensed",
						size = 12,
						color = { r = 1, g = 1, b = 1, a = 1 },
						align = "CENTER",
						anchor = "LEFT",
						pos = 0.25,
						offX = 0,
						offY = 0,
						outline = "NONE",
						shadColor = { r = 0, g = 0, b = 0, a = 1 },
						shadX = 1.5,
						shadY = -1,
					},
					text3 = {
						enabled = false,
						used = true,
						text = "T3",
						font = "Fira Sans Condensed",
						size = 12,
						color = { r = 1, g = 1, b = 1, a = 1 },
						align = "CENTER",
						anchor = "LEFT",
						pos = 0.5,
						offX = 0,
						offY = 0,
						outline = "NONE",
						shadColor = { r = 0, g = 0, b = 0, a = 1 },
						shadX = 1.5,
						shadY = -1,
					},
					text4 = {
						enabled = false,
						used = true,
						text = "T4",
						font = "Fira Sans Condensed",
						size = 12,
						color = { r = 1, g = 1, b = 1, a = 1 },
						align = "CENTER",
						anchor = "LEFT",
						pos = 0.75,
						offX = 0,
						offY = 0,
						outline = "NONE",
						shadColor = { r = 0, g = 0, b = 0, a = 1 },
						shadX = 1.5,
						shadY = -1,
					},
					text5 = {
						enabled = false,
						used = true,
						text = "T5",
						font = "Fira Sans Condensed",
						size = 12,
						color = { r = 1, g = 1, b = 1, a = 1 },
						align = "RIGHT",
						anchor = "LEFT",
						pos = 1,
						offX = -5,
						offY = 0,
						outline = "NONE",
						shadColor = { r = 0, g = 0, b = 0, a = 1 },
						shadX = 1.5,
						shadY = -1,
					},
				},
				customText = {				
					text1 = {
						enabled = false,
						used = true,
						edit = false,
						text = "Custom Text 1",
						font = "Fira Sans Condensed",
						size = 12,
						color = { r = 1, g = 1, b = 1, a = 1 },
						align = "CENTER",
						anchor = "TOPLEFT",
						pos = 0,
						offX = 0,
						offY = 0,
						outline = "NONE",
						shadColor = { r = 0, g = 0, b = 0, a = 1 },
						shadX = 1.5,
						shadY = -1,
					},
					text2 = {
						enabled = false,
						used = true,
						edit = false,
						text = "Custom Text 2",
						font = "Fira Sans Condensed",
						size = 12,
						color = { r = 1, g = 1, b = 1, a = 1 },
						align = "CENTER",
						anchor = "TOPRIGHT",
						pos = 0,
						offX = 0,
						offY = 0,
						outline = "NONE",
						shadColor = { r = 0, g = 0, b = 0, a = 1 },
						shadX = 1.5,
						shadY = -1,
					},
					text3 = {
						enabled = false,
						used = true,
						edit = false,
						text = "Custom Text 3",
						font = "Fira Sans Condensed",
						size = 12,
						color = { r = 1, g = 1, b = 1, a = 1 },
						align = "CENTER",
						anchor = "CENTER",
						pos = 0,
						offX = 0,
						offY = 0,
						outline = "NONE",
						shadColor = { r = 0, g = 0, b = 0, a = 1 },
						shadX = 1.5,
						shadY = -1,
					},
					text4 = {
						enabled = false,
						used = true,
						edit = false,
						text = "Custom Text 4",
						font = "Fira Sans Condensed",
						size = 12,
						color = { r = 1, g = 1, b = 1, a = 1 },
						align = "CENTER",
						anchor = "BOTTOMLEFT",
						pos = 0,
						offX = 0,
						offY = 0,
						outline = "NONE",
						shadColor = { r = 0, g = 0, b = 0, a = 1 },
						shadX = 1.5,
						shadY = -1,
					},
					text5 = {
						enabled = false,
						used = true,
						edit = false,
						text = "Custom Text 5",
						font = "Fira Sans Condensed",
						size = 12,
						color = { r = 1, g = 1, b = 1, a = 1 },
						align = "CENTER",
						anchor = "BOTTOMRIGHT",
						pos = 0,
						offX = 0,
						offY = 0,
						outline = "NONE",
						shadColor = { r = 0, g = 0, b = 0, a = 1 },
						shadX = 1.5,
						shadY = -1,
					},
				},
			},
		},
		
		barFrames = {
			frame1 = {
				enabled = true,
				name = "Bar Frame 1",
				grow = "UP",
				horizontal = false,
				sorting = "DESCENDING",
				padding = 0,
				
				posX = -300,
				posY = 0,
				width = 180,
				height = 25,
				relativeTo = "CENTER",
				
				transition = {
					hideTransitioned = true,
					
					showTI = true,
					style = "LINE",
					
					texture = "CDTL2 Smooth",
					textureColor = { r = 1, g = 1, b = 1, a = 0.5 },
					
					--height = 40,
					width = 5,
				},
				
				bgTexture = "CDTL2 Smooth",
				bgTextureColor = { r = 0.15, g = 0.15, b = 0.15, a = 0.5 },
				
				border = {
					style = "CDTL2 Shadow",
					color = { r = 0, g = 0, b = 0, a = 0.25 },
					size = 5,
					padding = 5,
					inset = 0,
				},
				
				bar = {
					iconEnabled = true,
					iconPosition = "LEFT",
					
					xPadding = 0,
					yPadding = 0,
				
					fgTexture = "CDTL2 Smooth",
					fgTextureColor = { r = 0.77647, g = 0.11765, b = 0.28235, a = 1 },
					bgTexture = "CDTL2 Smooth",
					bgTextureColor = { r = 0.15, g = 0.15, b = 0.15, a = 0.5 },
					
					border = {
						style = "None",
						color = { r = 1, g = 1, b = 1, a = 0.25 },
						size = 5,
						padding = 5,
						inset = 0,
					},
					
					text1 = {
						enabled = true,
						used = true,
						edit = false,
						text = "[cd.stacks]",
						font = "Fira Sans Condensed",
						size = 12,
						color = { r = 1, g = 1, b = 1, a = 1 },
						align = "CENTER",
						anchor = "LEFT",
						offX = 14,
						offY = 0,
						outline = "OUTLINE",
						shadColor = { r = 0, g = 0, b = 0, a = 0.5 },
						shadX = 0,
						shadY = 0,
					},
					text2 = {
						enabled = true,
						used = true,
						edit = false,
						text = "[cd.name]",
						font = "Fira Sans Condensed",
						size = 12,
						color = { r = 1, g = 1, b = 1, a = 1 },
						align = "LEFT",
						anchor = "LEFT",
						offX = 30,
						offY = 0,
						outline = "NONE",
						shadColor = { r = 0, g = 0, b = 0, a = 0.5 },
						shadX = 1.5,
						shadY = -1,
					},
					text3 = {
						enabled = true,
						used = true,
						edit = false,
						text = "[cd.time]",
						font = "Fira Sans Condensed",
						size = 12,
						color = { r = 1, g = 1, b = 1, a = 1 },
						align = "RIGHT",
						anchor = "RIGHT",
						offX = -5,
						offY = 0,
						outline = "NONE",
						shadColor = { r = 0, g = 0, b = 0, a = 0.5 },
						shadX = 1.5,
						shadY = -1,
					},
				}
			},
			frame2 = {
				enabled = true,
				name = "Bar Frame 2",
				grow = "UP",
				horizontal = false,
				padding = 0,
				
				posX = 300,
				posY = 0,
				width = 180,
				height = 25,
				relativeTo = "CENTER",
				
				transition = {
					hideTransitioned = true,
					
					showTI = true,
					style = "LINE",
					
					texture = "CDTL2 Smooth",
					textureColor = { r = 1, g = 1, b = 1, a = 0.5 },
					
					--height = 40,
					width = 5,
				},
				
				bgTexture = "CDTL2 Smooth",
				bgTextureColor = { r = 0.15, g = 0.15, b = 0.15, a = 0.5 },
				
				border = {
					style = "CDTL2 Shadow",
					color = { r = 0, g = 0, b = 0, a = 0.25 },
					size = 5,
					padding = 5,
					inset = 0,
				},
				
				bar = {
					iconEnabled = true,
					iconPosition = "LEFT",
					
					xPadding = 0,
					yPadding = 0,
				
					fgTexture = "CDTL2 Smooth",
					fgTextureColor = { r = 0.52941, g = 0.77647, b = 0.24314, a = 1 },
					bgTexture = "CDTL2 Smooth",
					bgTextureColor = { r = 0.15, g = 0.15, b = 0.15, a = 0.5 },
					
					border = {
						style = "None",
						color = { r = 1, g = 1, b = 1, a = 0.25 },
						size = 5,
						padding = 5,
						inset = 0,
					},
					
					text1 = {
						enabled = true,
						used = true,
						edit = false,
						text = "[cd.stacks]",
						font = "Fira Sans Condensed",
						size = 12,
						color = { r = 1, g = 1, b = 1, a = 1 },
						align = "CENTER",
						anchor = "LEFT",
						offX = 14,
						offY = 0,
						outline = "OUTLINE",
						shadColor = { r = 0, g = 0, b = 0, a = 0.5 },
						shadX = 0,
						shadY = 0,
					},
					text2 = {
						enabled = true,
						used = true,
						edit = false,
						text = "[cd.name]",
						font = "Fira Sans Condensed",
						size = 12,
						color = { r = 1, g = 1, b = 1, a = 1 },
						align = "LEFT",
						anchor = "LEFT",
						offX = 30,
						offY = 0,
						outline = "NONE",
						shadColor = { r = 0, g = 0, b = 0, a = 0.5 },
						shadX = 1.5,
						shadY = -1,
					},
					text3 = {
						enabled = true,
						used = true,
						edit = false,
						text = "[cd.time]",
						font = "Fira Sans Condensed",
						size = 12,
						color = { r = 1, g = 1, b = 1, a = 1 },
						align = "RIGHT",
						anchor = "RIGHT",
						offX = -5,
						offY = 0,
						outline = "NONE",
						shadColor = { r = 0, g = 0, b = 0, a = 0.5 },
						shadX = 1.5,
						shadY = -1,
					},
				}
			},
			frame3 = {
				enabled = true,
				name = "Bar Frame 3",
				grow = "UP",
				horizontal = false,
				padding = 0,
				
				posX = 0,
				posY = 175,
				width = 180,
				height = 25,
				relativeTo = "CENTER",
				
				transition = {
					hideTransitioned = true,
					
					showTI = true,
					style = "LINE",
					
					texture = "CDTL2 Smooth",
					textureColor = { r = 1, g = 1, b = 1, a = 0.5 },
					
					--height = 40,
					width = 5,
				},
				
				bgTexture = "CDTL2 Smooth",
				bgTextureColor = { r = 0.15, g = 0.15, b = 0.15, a = 0.5 },
				
				border = {
					style = "CDTL2 Shadow",
					color = { r = 0, g = 0, b = 0, a = 0.25 },
					size = 5,
					padding = 5,
					inset = 0,
				},
				
				bar = {
					iconEnabled = true,
					iconPosition = "LEFT",
					
					xPadding = 0,
					yPadding = 0,
				
					fgTexture = "CDTL2 Smooth",
					fgTextureColor = { r = 0.15294, g = 0.63922, b = 0.77647, a = 1 },
					bgTexture = "CDTL2 Smooth",
					bgTextureColor = { r = 0.15, g = 0.15, b = 0.15, a = 0.5 },
					
					border = {
						style = "None",
						color = { r = 1, g = 1, b = 1, a = 0.25 },
						size = 5,
						padding = 5,
						inset = 0,
					},
					
					text1 = {
						enabled = true,
						used = true,
						edit = false,
						text = "[cd.stacks]",
						font = "Fira Sans Condensed",
						size = 12,
						color = { r = 1, g = 1, b = 1, a = 1 },
						align = "CENTER",
						anchor = "LEFT",
						offX = 14,
						offY = 0,
						outline = "OUTLINE",
						shadColor = { r = 0, g = 0, b = 0, a = 0.5 },
						shadX = 0,
						shadY = 0,
					},
					text2 = {
						enabled = true,
						used = true,
						edit = false,
						text = "[cd.name]",
						font = "Fira Sans Condensed",
						size = 12,
						color = { r = 1, g = 1, b = 1, a = 1 },
						align = "LEFT",
						anchor = "LEFT",
						offX = 30,
						offY = 0,
						outline = "NONE",
						shadColor = { r = 0, g = 0, b = 0, a = 0.5 },
						shadX = 1.5,
						shadY = -1,
					},
					text3 = {
						enabled = true,
						used = true,
						edit = false,
						text = "[cd.time]",
						font = "Fira Sans Condensed",
						size = 12,
						color = { r = 1, g = 1, b = 1, a = 1 },
						align = "RIGHT",
						anchor = "RIGHT",
						offX = -5,
						offY = 0,
						outline = "NONE",
						shadColor = { r = 0, g = 0, b = 0, a = 0.5 },
						shadX = 1.5,
						shadY = -1,
					},
				}
			},
		},
		
		ready = {
			ready1 = {
				enabled = true,
				name = "Ready 1",
				grow = "DOWN",
				padding = 0,
				
				nTime = 5,
				nSound = "CDTL2 Click",
				
				hTime = 10,
				hSound = "None",
			
				posX = -300,
				posY = -75,
				relativeTo = "CENTER",
				
				bgTexture = "CDTL2 Smooth",
				bgTextureColor = { r = 0.15, g = 0.15, b = 0.15, a = 0.5 },
				
				border = {
					style = "CDTL2 Shadow",
					color = { r = 0, g = 0, b = 0, a = 0.25 },
					size = 5,
					padding = 5,
					inset = 0,
				},
				
				icons = {
					size = 50,
					
					xPadding = 0,
					yPadding = 0,
					
					border = {
						style = "None",
						color = { r = 0, g = 0, b = 0, a = 0.25 },
						size = 5,
						padding = 5,
						inset = 0,
					},
					
					hlBorder = {
						style = "None",
						color = { r = 1, g = 1, b = 1, a = 0.25 },
						size = 5,
						padding = 5,
						inset = 0,
					},
					
					text1 = {
						enabled = true,
						used = true,
						edit = false,
						text = "[cd.name.s]",
						font = "Fira Sans Condensed",
						size = 18,
						color = { r = 1, g = 1, b = 1, a = 1 },
						align = "CENTER",
						anchor = "CENTER",
						offX = 0,
						offY = 7,
						outline = "OUTLINE",
						shadColor = { r = 0, g = 0, b = 0, a = 0.5 },
						shadX = 1.5,
						shadY = -1,
					},
					text2 = {
						enabled = true,
						used = true,
						edit = false,
						text = "READY",
						font = "Fira Sans Condensed",
						size = 12,
						color = { r = 1, g = 1, b = 1, a = 1 },
						align = "CENTER",
						anchor = "CENTER",
						offX = 0,
						offY = -7,
						outline = "OUTLINE",
						shadColor = { r = 0, g = 0, b = 0, a = 0.5 },
						shadX = 1.5,
						shadY = -1,
					},
					text3 = {
						enabled = false,
						used = true,
						edit = false,
						text = "[cd.type]",
						font = "Fira Sans Condensed",
						size = 10,
						color = { r = 1, g = 1, b = 1, a = 1 },
						align = "CENTER",
						anchor = "BOTTOM",
						offX = 0,
						offY = 7,
						outline = "OUTLINE",
						shadColor = { r = 0, g = 0, b = 0, a = 0.5 },
						shadX = 1.5,
						shadY = -1,
					},
				},
			},
			ready2 = {
				enabled = true,
				name = "Ready 2",
				grow = "DOWN",
				padding = 0,
				
				nTime = 5,
				nSound = "CDTL2 Tinks",
				
				hTime = 10,
				hSound = "None",
			
				posX = 300,
				posY = -75,
				relativeTo = "CENTER",
				
				bgTexture = "CDTL2 Smooth",
				bgTextureColor = { r = 0.15, g = 0.15, b = 0.15, a = 0.5 },
				
				border = {
					style = "CDTL2 Shadow",
					color = { r = 0, g = 0, b = 0, a = 0.25 },
					size = 5,
					padding = 5,
					inset = 0,
				},
				
				icons = {
					size = 50,
					
					xPadding = 0,
					yPadding = 0,
					
					border = {
						style = "None",
						color = { r = 0, g = 0, b = 0, a = 1 },
						size = 5,
						padding = 5,
						inset = 0,
					},
					
					hlBorder = {
						style = "None",
						color = { r = 1, g = 1, b = 1, a = 1 },
						size = 5,
						padding = 5,
						inset = 0,
					},
					
					text1 = {
						enabled = true,
						used = true,
						edit = false,
						text = "[cd.name.s]",
						font = "Fira Sans Condensed",
						size = 18,
						color = { r = 1, g = 1, b = 1, a = 1 },
						align = "CENTER",
						anchor = "CENTER",
						offX = 0,
						offY = 7,
						outline = "OUTLINE",
						shadColor = { r = 0, g = 0, b = 0, a = 0.5 },
						shadX = 1.5,
						shadY = -1,
					},
					text2 = {
						enabled = true,
						used = true,
						edit = false,
						text = "READY",
						font = "Fira Sans Condensed",
						size = 12,
						color = { r = 1, g = 1, b = 1, a = 1 },
						align = "CENTER",
						anchor = "CENTER",
						offX = 0,
						offY = -7,
						outline = "OUTLINE",
						shadColor = { r = 0, g = 0, b = 0, a = 0.5 },
						shadX = 1.5,
						shadY = -1,
					},
					text3 = {
						enabled = false,
						used = true,
						edit = false,
						text = "[cd.type]",
						font = "Fira Sans Condensed",
						size = 10,
						color = { r = 1, g = 1, b = 1, a = 1 },
						align = "CENTER",
						anchor = "BOTTOM",
						offX = 0,
						offY = 7,
						outline = "OUTLINE",
						shadColor = { r = 0, g = 0, b = 0, a = 0.5 },
						shadX = 1.5,
						shadY = -1,
					},
				},
			},
			ready3 = {
				enabled = true,
				name = "Ready 3",
				grow = "CENTER_H",
				padding = 0,
				
				nTime = 5,
				nSound = "CDTL2 Tinks",
				
				hTime = 10,
				hSound = "None",
			
				posX = 0,
				posY = 100,
				relativeTo = "CENTER",
				
				bgTexture = "CDTL2 Smooth",
				bgTextureColor = { r = 0.15, g = 0.15, b = 0.15, a = 0.5 },
				
				border = {
					style = "CDTL2 Shadow",
					color = { r = 0, g = 0, b = 0, a = 0.25 },
					size = 5,
					padding = 5,
					inset = 0,
				},
				
				icons = {
					size = 50,
					
					xPadding = 0,
					yPadding = 0,
					
					border = {
						style = "None",
						color = { r = 0, g = 0, b = 0, a = 1 },
						size = 5,
						padding = 5,
						inset = 0,
					},
					
					hlBorder = {
						style = "None",
						color = { r = 1, g = 1, b = 1, a = 1 },
						size = 5,
						padding = 5,
						inset = 0,
					},
					
					text1 = {
						enabled = true,
						used = true,
						edit = false,
						text = "[cd.name.s]",
						font = "Fira Sans Condensed",
						size = 18,
						color = { r = 1, g = 1, b = 1, a = 1 },
						align = "CENTER",
						anchor = "CENTER",
						offX = 0,
						offY = 7,
						outline = "OUTLINE",
						shadColor = { r = 0, g = 0, b = 0, a = 0.5 },
						shadX = 1.5,
						shadY = -1,
					},
					text2 = {
						enabled = true,
						used = true,
						edit = false,
						text = "READY",
						font = "Fira Sans Condensed",
						size = 12,
						color = { r = 1, g = 1, b = 1, a = 1 },
						align = "CENTER",
						anchor = "CENTER",
						offX = 0,
						offY = -7,
						outline = "OUTLINE",
						shadColor = { r = 0, g = 0, b = 0, a = 0.5 },
						shadX = 1.5,
						shadY = -1,
					},
					text3 = {
						enabled = false,
						used = true,
						edit = false,
						text = "[cd.type]",
						font = "Fira Sans Condensed",
						size = 10,
						color = { r = 1, g = 1, b = 1, a = 1 },
						align = "CENTER",
						anchor = "BOTTOM",
						offX = 0,
						offY = 7,
						outline = "OUTLINE",
						shadColor = { r = 0, g = 0, b = 0, a = 0.5 },
						shadX = 1.5,
						shadY = -1,
					},
				},
			},
		},
		
		holders = {
			iconPadding = 12,
			iconSize = 48,
			barPadding = 6,
			barWidth = 150,
			barHeight = 22,
			fontSize = 10,
		},
		
		tables = {
			spells = {
				
			},
			petSpells = {
				
			},
			items = {
				
			},
			buffs = {
				
			},
			debuffs = {
				
			},
			offensives = {
				
			},
		},
	}
}

function CDTL2:OnInitialize()
	self.db = LibStub("AceDB-3.0"):New("CDTL2DB", defaults, true)
	self.registry = LibStub("AceConfigRegistry-3.0")
	self.profile = LibStub("AceDBOptions-3.0"):GetOptionsTable(self.db)
	
	self.db.RegisterCallback(self, "OnProfileChanged", "RefreshConfig")
	self.db.RegisterCallback(self, "OnProfileCopied", "RefreshConfig")
	self.db.RegisterCallback(self, "OnProfileReset", "RefreshConfig")
	
	LibStub("AceConfig-3.0"):RegisterOptionsTable("CDTL2", CDTL2:GetMainOptions())
	LibStub("AceConfig-3.0"):RegisterOptionsTable("CDTL2Lanes", CDTL2:GetLaneOptions())
	LibStub("AceConfig-3.0"):RegisterOptionsTable("CDTL2Ready", CDTL2:GetReadyOptions())
	LibStub("AceConfig-3.0"):RegisterOptionsTable("CDTL2BarFrames", CDTL2:GetBarFrameOptions())
	LibStub("AceConfig-3.0"):RegisterOptionsTable("CDTL2Filters", CDTL2:GetFilterOptions())
	LibStub("AceConfig-3.0"):RegisterOptionsTable("CDTL2Profiles", self.profile)
	
	self.optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("CDTL2", "CDTL2")
	self.optionsFrame.oLanes = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("CDTL2Lanes", "Lanes", "CDTL2")
	self.optionsFrame.oReady = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("CDTL2Ready", "Ready", "CDTL2")
	self.optionsFrame.oBarFrames = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("CDTL2BarFrames", "Bars", "CDTL2")
	self.optionsFrame.oFilter = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("CDTL2Filters", "Filters", "CDTL2")
	self.optionsFrame.profile = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("CDTL2Profiles", "Profiles", "CDTL2")
	
	self:RegisterChatCommand("cdtl2", "ChatCommand")
    self:RegisterChatCommand("cooldowntimeline2", "ChatCommand")
end

function CDTL2:OnEnable()
	self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	--self:RegisterEvent("PLAYER_ENTERING_WORLD")
	self:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED")

	CDTL2:CreateLanes()
	CDTL2:CreateBarFrames()
	CDTL2:CreateReadyFrames()
	CDTL2:CreateHolders()
	
	private.CreateUnlockFrame()
	private.CreateDebugFrame()
	
	CDTL2:Print("Loaded version: "..CDTL2.version)
	CDTL2:Print("Type /cdtl2 or /cooldowntimeline2 for options")
	
	C_Timer.After(10, function()
		CDTL2:GetCharacterData()
		CDTL2:ScanCurrentCooldowns(CDTL2.player["class"], CDTL2.player["race"])
	end)
end

function CDTL2:ChatCommand(input)
    if not input or input:trim() == "" then
        InterfaceOptionsFrame_OpenToCategory(CDTL2.optionsFrame)
        InterfaceOptionsFrame_OpenToCategory(CDTL2.optionsFrame.profile)
        InterfaceOptionsFrame_OpenToCategory(CDTL2.optionsFrame)
	elseif input:trim() == "lock" then
		CDTL2:ToggleFrameLock()
	elseif input:trim() == "unlock" then
		CDTL2:ToggleFrameLock()
	elseif input:trim() == "debug" then
		CDTL2:ToggleDebug()
    else
        --LibStub("AceConfigCmd-3.0"):HandleCommand("wh", "WelcomeHome", input)
    end
end

private.CreateDebugFrame = function()
	local frameName = "CDTL2_Debug_Frame"
	local f = CreateFrame("Frame", frameName, UIParent, BackdropTemplateMixin and "BackdropTemplate" or nil)
	
	f:ClearAllPoints()
	f:SetPoint("TOP", 300, -75)
	f:SetSize(300, 200)
	
	-- BACKGROUND
	f.bg = f:CreateTexture(nil, "BACKGROUND")
	f.bg:SetAllPoints(true)
	f.bg:SetColorTexture( 
		CDTL2.colors["db"]["r"],
		CDTL2.colors["db"]["g"],
		CDTL2.colors["db"]["b"],
		CDTL2.colors["db"]["a"]
	)
	
	f.text = f:CreateFontString(nil,"ARTWORK")
	f.text:SetFont(CDTL2.LSM:Fetch("font", "Fira Sans Condensed"), 12, "NONE")
	f.text:SetShadowColor( 0, 0, 0, 1 )
	f.text:SetShadowOffset(1.5, -1)
	f.text:SetText("CDTL2: Debug Enabled")
	f.text:SetPoint("TOP", 0, -5)
	
	local b = CreateFrame("Button", frameName.."_B_Reload", f, "UIPanelButtonTemplate", BackdropTemplateMixin and "BackdropTemplate" or nil)
	b:SetSize(80 ,25) -- width, height
	b:SetText("Reload")
	b:SetPoint("TOPLEFT", 5, -25)
	b:SetScript("OnClick", function()
		ReloadUI()
	end)
	
	local b = CreateFrame("Button", frameName.."_B_Options", f, "UIPanelButtonTemplate", BackdropTemplateMixin and "BackdropTemplate" or nil)
	b:SetSize(80 ,25) -- width, height
	b:SetText("Options")
	b:SetPoint("TOPLEFT", 5, -50)
	b:SetScript("OnClick", function()
		InterfaceOptionsFrame_OpenToCategory(CDTL2.optionsFrame)
        InterfaceOptionsFrame_OpenToCategory(CDTL2.optionsFrame.profile)
        InterfaceOptionsFrame_OpenToCategory(CDTL2.optionsFrame)
	end)
	
	local b = CreateFrame("Button", frameName.."_B_UnLock", f, "UIPanelButtonTemplate", BackdropTemplateMixin and "BackdropTemplate" or nil)
	b:SetSize(80 ,25) -- width, height
	b:SetText("(Un)Lock")
	b:SetPoint("TOPLEFT", 5, -75)
	b:SetScript("OnClick", function()
		CDTL2:ToggleFrameLock()
	end)
	
	local b = CreateFrame("Button", frameName.."_B_TestCode1", f, "UIPanelButtonTemplate", BackdropTemplateMixin and "BackdropTemplate" or nil)
	b:SetSize(80 ,25) -- width, height
	b:SetText("TestCode1")
	b:SetPoint("TOPLEFT", 5, -100)
	b:SetScript("OnClick", function()
		--CDTL2:ScanSpellData("MAGE")
		
		for _, spell in pairs(CDTL2.spellData) do
			--CDTL2:Print("SPELL DATA: "..spell["id"].." - "..spell["name"].." - "..spell["rank"])
		end
	end)
		
	-- DRAG AND DROP MOVEMENT
	f:SetMovable(true)
	f:EnableMouse(true)
	f:RegisterForDrag("LeftButton")
	f:SetScript("OnDragStart", f.StartMoving)
	f:SetScript("OnDragStop", f.StopMovingOrSizing)
	
	if not CDTL2.db.profile.global["debugMode"] then
		f:Hide()
	end
	
	CDTL2.debugFrame = f
end

private.CreateUnlockFrame = function()
	local f = CreateFrame("Frame", "CDTL2_Unlock_Frame", UIParent, BackdropTemplateMixin and "BackdropTemplate" or nil)
	
	f:ClearAllPoints()
	f:SetPoint("TOP", 0, -70)
	f:SetSize(180, 70)
	
	-- BACKGROUND
	f.bg = f:CreateTexture(nil, "BACKGROUND")
	f.bg:SetAllPoints(true)
	f.bg:SetColorTexture( 
		CDTL2.colors["db"]["r"],
		CDTL2.colors["db"]["g"],
		CDTL2.colors["db"]["b"],
		CDTL2.colors["db"]["a"]
	)
	
	-- BORDER
	f.bd = CreateFrame("Frame", "CDTL2_Unlock_Frame_BD", UIParent, BackdropTemplateMixin and "BackdropTemplate" or nil)
	f.bd:SetParent(f)
	CDTL2:SetBorder(f.bd, {
					style = "CDTL2 Shadow",
					color = { r = 0, g = 0, b = 0, a = 0.25 },
					size = 5,
					padding = 5,
					inset = 0,
				})
	f.bd:SetFrameLevel(f:GetFrameLevel() + 1)
	
	-- TEXT
	f.text = f:CreateFontString(nil,"ARTWORK")
	f.text:SetFont(CDTL2.LSM:Fetch("font", "Fira Sans Condensed"), 12, "NONE")
	f.text:SetShadowColor( 0, 0, 0, 1 )
	f.text:SetShadowOffset(1.5, -1)
	f.text:SetText("CDTL2\nFrames currently unlocked\nDrag and drop to move")
	f.text:SetPoint("TOP", 0, -5)
	
	local b = CreateFrame("Button", "CDTL2_Unlock_Frame_Button", f, "UIPanelButtonTemplate", BackdropTemplateMixin and "BackdropTemplate" or nil)
	b:SetSize(80 ,25) -- width, height
	b:SetText("Lock")
	b:SetPoint("BOTTOM", 0, 4)
	b:SetScript("OnClick", function()
		CDTL2:ToggleFrameLock()
	end)
	
	-- ON UPDATE
	f:HookScript("OnUpdate", function(self, elapsed)
		
	end)
	
	if not CDTL2.db.profile.global["unlockFrames"] then
		f:Hide()
	end
	
	CDTL2.unlockFrame = f
end

function CDTL2:COMBAT_LOG_EVENT_UNFILTERED()
	local _, subevent, _, sourceGUID, sourceName, _, _, destGUID, destName, _, _ = CombatLogGetCurrentEventInfo()
	
	if subevent == "SPELL_AURA_APPLIED" then
		if sourceGUID == CDTL2.player["guid"] or destGUID == CDTL2.player["guid"] then
			local spellID, spellName, _, auraType, _, _, _, _, _, _, _, _, _ = select(12, CombatLogGetCurrentEventInfo())
			auraType = auraType:lower().."s"
			
			if CDTL2.db.profile.global["debugMode"] then
				CDTL2:Print("AURA APPLIED: "..spellID.." - "..spellName.." - "..auraType.." - "..tostring(sourceName).." - "..destName)
			end
			
			-- PLAYER AURAS
			if destGUID == CDTL2.player["guid"] then
				local s = CDTL2:GetSpellSettings(spellName, auraType)
				if s then
					local ef = CDTL2:GetExistingCooldown(s["name"], auraType)
					if ef then
						CDTL2:SendToLane(ef)
						CDTL2:SendToBarFrame(ef)
					else
						--if CDTL2.db.profile.global["tracking"]["enableBuffs"] and auraType == "buffs" then
						if CDTL2.db.profile.global["buffs"]["enabled"] and auraType == "buffs" then
							CDTL2:CreateCooldown(CDTL2:GetUID(),auraType , s)
							if not CDTL2:IsUsedBy("buffs", spellID) then
								CDTL2:AddUsedBy("buffs", spellID, CDTL2.player["guid"])
							end
						--elseif CDTL2.db.profile.global["tracking"]["enableDebuffs"] and auraType == "debuffs" then
						elseif CDTL2.db.profile.global["debuffs"]["enabled"] and auraType == "debuffs" then
							CDTL2:CreateCooldown(CDTL2:GetUID(),auraType , s)
							if not CDTL2:IsUsedBy("debuffs", spellID) then
								CDTL2:AddUsedBy("debuffs", spellID, CDTL2.player["guid"])
							end
						end
					end
				else
					s = CDTL2:AuraExists("player", spellName)
					if s then
						--s["lane"] = 2
						--s["barFrame"] = 2
						--s["readyFrame"] = 2
						s["highlight"] = false
						s["pinned"] = false
						
						s["usedBy"] = { CDTL2.player["guid"] }
						
						local link, _ = GetSpellLink(spellID)
						s["link"] = link
						
						if auraType == "buffs" then
							--s["enabled"] = CDTL2.db.profile.global["tracking"]["showBuffsDefault"]
							s["enabled"] = CDTL2.db.profile.global["buffs"]["showByDefault"]
							s["lane"] = CDTL2.db.profile.global["buffs"]["defaultLane"]
							s["barFrame"] = CDTL2.db.profile.global["buffs"]["defaultBar"]
							s["readyFrame"] = CDTL2.db.profile.global["buffs"]["defaultReady"]
						elseif auraType == "debuffs" then
							--s["enabled"] = CDTL2.db.profile.global["tracking"]["showDebuffsDefault"]
							s["enabled"] = CDTL2.db.profile.global["debuffs"]["showByDefault"]
							s["lane"] = CDTL2.db.profile.global["debuffs"]["defaultLane"]
							s["barFrame"] = CDTL2.db.profile.global["debuffs"]["defaultBar"]
							s["readyFrame"] = CDTL2.db.profile.global["debuffs"]["defaultReady"]
						end
					
						--CDTL2:Print("ADDING: "..s["id"].." - "..s["name"])
						table.insert(CDTL2.db.profile.tables[auraType], s)
						
						--if CDTL2.db.profile.global["tracking"]["enableBuffs"] and auraType == "buffs" then
						if CDTL2.db.profile.global["buffs"]["enabled"] and auraType == "buffs" then
							CDTL2:CreateCooldown(CDTL2:GetUID(),auraType , s)
						--elseif CDTL2.db.profile.global["tracking"]["enableDebuffs"] and auraType == "debuffs" then
						elseif CDTL2.db.profile.global["debuffs"]["enabled"] and auraType == "debuffs" then
							CDTL2:CreateCooldown(CDTL2:GetUID(),auraType , s)
						end
					end
				end
			
			-- OFFENSIVE AURAS
			else
				local s = CDTL2:GetSpellSettings(spellName, "offensives")
				if s then
					local ef = CDTL2:GetExistingCooldown(s["name"], "offensives", destGUID)
					if ef then
						CDTL2:SendToLane(ef)
						CDTL2:SendToBarFrame(ef)
						--ef.data["targetID"] = destGUID
						--ef.data["targetName"] = destName
						ef.data["currentCD"] = ef.data["baseCD"]
					else
						local rcd = CDTL2:RecycleOffensiveCD()
						if rcd then
							CDTL2:SendToLane(rcd)
							CDTL2:SendToBarFrame(rcd)
							
							rcd.data["id"] = s["id"]
							rcd.data["name"] = s["name"]
							rcd.data["rank"] = s["rank"]
							rcd.data["desc"] = s["desc"]
							rcd.data["icon"] = s["icon"]
							
							rcd.data["ignored"] = ""
							rcd.data["highlighted"] = ""
							
							rcd.data["lane"] = s["lane"]
							rcd.data["barFrame"] = s["barFrame"]
							rcd.data["readyFrame"] = s["readyFrame"]
							
							rcd.data["baseCD"] = s["bCD"] / 1000
							rcd.data["currentCD"] = s["bCD"] / 1000
							
							rcd.icon.icon = rcd.data["icon"]
							rcd.icon.name = rcd.data["name"]
							rcd.icon.rank = rcd.data["rank"]
							rcd.icon.lane = rcd.data["lane"]
							
							CDTL2:RefreshBar(rcd)
							CDTL2:RefreshIcon(rcd)
						else
							s["targetID"] = destGUID
							s["targetName"] = destName
							
							--if CDTL2.db.profile.global["tracking"]["enableOffensive"] then
							if CDTL2.db.profile.global["offensives"]["enabled"] then
								CDTL2:CreateCooldown(CDTL2:GetUID(),"offensives" , s)
								if not CDTL2:IsUsedBy("offensives", spellID) then
									CDTL2:AddUsedBy("offensives", spellID, CDTL2.player["guid"])
								end
							end
						end
					end
				else
					--s = CDTL2:AuraExists("player", spellName)
					--if s then
						--[[local s = {}
						
						s["lane"] = 3
						s["barFrame"] = 3
						s["targetID"] = destGUID]]--
						
						local _, _, icon, _, _, _, _ = GetSpellInfo(spellID)
						
						local s = {
							id = spellID,
							bCD = 0,
							name = spellName,
							type = "offensives",
							icon = icon,
							--stacks = count,
							--endTime = expirationTime,
							
							--lane = 3,
							--barFrame = 3,
							--readyFrame = 0,
							lane = CDTL2.db.profile.global["offensives"]["defaultLane"],
							barFrame = CDTL2.db.profile.global["offensives"]["defaultBar"],
							readyFrame = CDTL2.db.profile.global["offensives"]["defaultReady"],
							--targetID = destGUID,
						}
						
						--s["enabled"] = CDTL2.db.profile.global["tracking"]["showOffensiveDefault"]
						s["enabled"] = CDTL2.db.profile.global["offensives"]["showByDefault"]
						s["highlight"] = false
						s["pinned"] = false
						
						s["usedBy"] = { CDTL2.player["guid"] }
						
						local link, _ = GetSpellLink(spellID)
						s["link"] = link
					
						--CDTL2:Print("ADDING: "..s["id"].." - "..s["name"])
						table.insert(CDTL2.db.profile.tables["offensives"], s)
						
						s["targetID"] = destGUID
						s["targetName"] = destName
						
						--if CDTL2.db.profile.global["tracking"]["enableOffensive"] then
						if CDTL2.db.profile.global["offensives"]["enabled"] then
							CDTL2:CreateCooldown(CDTL2:GetUID(),"offensives" , s)
						end
					--end
				end
			end
		end
	elseif subevent == "SPELL_AURA_REFRESH" then
		if sourceGUID == CDTL2.player["guid"] then
			local spellID, spellName, _, auraType, _, _, _, _, _, _, _, _, _ = select(12, CombatLogGetCurrentEventInfo())
			auraType = auraType:lower().."s"
			
			if CDTL2.db.profile.global["debugMode"] then
				--CDTL2:Print("AURA REFRESH: "..spellID.." - "..spellName.." - "..auraType.." - "..sourceName.." - "..destName)
			end
			
			local ef = CDTL2:GetExistingCooldown(spellName, "offensives", destGUID)
			if ef then
				--CDTL2:SendToLane(ef)
				--ef.data["targetID"] = destGUID
				--ef.data["targetName"] = destName
				ef.data["currentCD"] = ef.data["baseCD"]
				--CDTL2:Print("RESETTING: "..spellID.." - "..spellName.." - "..auraType.." - "..sourceName.." - "..destName)
			end
		end		
	elseif subevent == "SPELL_AURA_REMOVED" then
		if sourceGUID == CDTL2.player["guid"] then
			local spellID, spellName, _, auraType, _, _, _, _, _, _, _, _, _ = select(12, CombatLogGetCurrentEventInfo())
			auraType = auraType:lower().."s"
			
			if CDTL2.db.profile.global["debugMode"] then
				--CDTL2:Print("AURA REMOVED: "..spellID.." - "..spellName.." - "..auraType.." - "..sourceName.." - "..destName)
			end
			
			local ef = CDTL2:GetExistingCooldown(spellName, "offensives", destGUID)
			if ef then
				--CDTL2:SendToLane(ef)
				--ef.data["targetID"] = destGUID
				--ef.data["targetName"] = destName
				ef.data["currentCD"] = -1
				--CDTL2:Print("RESETTING: "..spellID.." - "..spellName.." - "..auraType.." - "..sourceName.." - "..destName)
			end
		end
	end
end

--function CDTL2:PLAYER_ENTERING_WORLD(...)
	
--end

function CDTL2:UNIT_SPELLCAST_SUCCEEDED(...)
	local _, unitTarget, castGUID, spellID = ...
	
	-- Spell ID 836 is a spell that gets cast on login
	if unitTarget == "player" and spellID ~= 836 then
		CDTL2:GetCharacterData()
		
		local _, _, icon, _, _, _, _ = GetSpellInfo(spellID)
		local subtext = GetSpellSubtext()
		
		if CDTL2.db.profile.global["debugMode"] then
			CDTL2:Print("SPELLCAST: "..castGUID)
			--CDTL2:Print("SPELLCAST: "..CDTL2:GetSpellName(spellID))
		end
		
		-- STANDARD SPELLS
		local spellName = CDTL2:GetSpellName(spellID, CDTL2.player["class"], CDTL2.player["race"])
		local s = CDTL2:GetSpellSettings(spellName, "spells")
		if s then
			--CDTL2:Print("FOUND: "..s["id"].." - "..s["name"])
			local ef = CDTL2:GetExistingCooldown(s["name"], "spells")
			if ef then
				--CDTL2:Print("EXISTING FOUND: "..s["id"].." - "..s["name"])
				CDTL2:SendToLane(ef)
				CDTL2:SendToBarFrame(ef)
			else
				--CDTL2:Print("CREATING NEW: "..s["id"].." - "..s["name"])
				--if CDTL2.db.profile.global["tracking"]["enableSpells"] then
				if CDTL2.db.profile.global["spells"]["enabled"] then
					CDTL2:CreateCooldown(CDTL2:GetUID(),"spells" , s)
					
					if CDTL2:IsUsedBy("spells", spellID) then
						--CDTL2:Print("USEDBY MATCH: "..s["id"])
					else
						--CDTL2:Print("NEW USEDBY: "..s["id"])
						CDTL2:AddUsedBy("spells", spellID, CDTL2.player["guid"])
					end
				end
			end
		else
			--s = CDTL2:GetSpellData(spellID, CDTL2.player["class"], CDTL2.player["race"])
			s = CDTL2:GetSpellData(spellID)
			if s then
				s["icon"] = icon
				s["lane"] = CDTL2.db.profile.global["spells"]["defaultLane"]
				s["barFrame"] = CDTL2.db.profile.global["spells"]["defaultBar"]
				s["readyFrame"] = CDTL2.db.profile.global["spells"]["defaultReady"]
				
				--s["enabled"] = CDTL2.db.profile.global["tracking"]["showSpellsDefault"]
				s["enabled"] = CDTL2.db.profile.global["spells"]["showByDefault"]
				s["highlight"] = false
				s["pinned"] = false
				
				s["usedBy"] = { CDTL2.player["guid"] }
				
				local link, _ = GetSpellLink(spellID)
				s["link"] = link
				
				--CDTL2:Print("ADDING: "..s["id"].." - "..s["name"])
				table.insert(CDTL2.db.profile.tables["spells"], s)
				
				--if CDTL2.db.profile.global["tracking"]["enableSpells"] then
				if CDTL2.db.profile.global["spells"]["enabled"] then
					CDTL2:CreateCooldown(CDTL2:GetUID(),"spells" , s)
				end
			else
				-- ITEM SPELLS
				--local spellName, spellID = GetItemSpell(itemId)
				local s = CDTL2:GetSpellSettings(spellName, "items", spellID)
				if s then
					local ef = CDTL2:GetExistingCooldown(s["name"], "items")
					--if CDTL2:IsValidItem(s["itemID"]) then
					if ef then
						CDTL2:SendToLane(ef)
						CDTL2:SendToBarFrame(ef)
					else
						--CDTL2:Print("FOUND: "..s["id"].." - "..s["name"])
						
						--if CDTL2.db.profile.global["tracking"]["enableItems"] then
						if CDTL2.db.profile.global["items"]["enabled"] then
							if not CDTL2:IsUsedBy("items", spellID) then
								CDTL2:AddUsedBy("items", spellID, CDTL2.player["guid"])
							end
							
							CDTL2:CreateCooldown(CDTL2:GetUID(),"items" , s)
						end
					end
				else
					s = CDTL2:GetItemSpell(spellID)
					if s then
						if CDTL2:IsValidItem(s["itemID"]) then
							--CDTL2:Print("ADDING: "..s["id"].." - "..s["name"])
							s["usedBy"] = { CDTL2.player["guid"] }
							table.insert(CDTL2.db.profile.tables["items"], s)
							
							--if CDTL2.db.profile.global["tracking"]["enableItems"] then
							if CDTL2.db.profile.global["items"]["enabled"] then
								CDTL2:CreateCooldown(CDTL2:GetUID(),"items" , s)
							end
						end
					else
						--CDTL2:Print("NOTFOUND: "..spellID)
					end
				end
			end
		end
	elseif unitTarget == "pet" then
		local _, _, icon, _, _, _, _ = GetSpellInfo(spellID)
		local subtext = GetSpellSubtext()
		
		if CDTL2.db.profile.global["debugMode"] then
			CDTL2:Print("PETCAST: "..castGUID)
		end
		
		-- PET SPELLS		
		local spellName = CDTL2:GetSpellName(spellID, CDTL2.player["class"], CDTL2.player["race"])
		local s = CDTL2:GetSpellSettings(spellName, "petSpells")
		--local s = CDTL2:GetSpellSettings(spellID, "petSpells")
		if s then
			--CDTL2:Print("FOUND: "..s["id"].." - "..s["name"])
			local ef = CDTL2:GetExistingCooldown(s["name"], "petSpells")
			if ef then
				--CDTL2:Print("EXISTING FOUND: "..s["id"].." - "..s["name"])
				CDTL2:SendToLane(ef)
				CDTL2:SendToBarFrame(ef)
			else
				--CDTL2:Print("CREATING NEW: "..s["id"].." - "..s["name"])
				--if CDTL2.db.profile.global["tracking"]["enablePetSpells"] then
				if CDTL2.db.profile.global["petSpells"]["enabled"] then
					CDTL2:CreateCooldown(CDTL2:GetUID(),"petSpells" , s)
					
					if not CDTL2:IsUsedBy("petSpells", spellID) then
						CDTL2:AddUsedBy("petSpells", spellID, CDTL2.player["guid"])
					end
				end
			end
		else
			--s = CDTL2:GetSpellData(spellID, CDTL2.player["class"], CDTL2.player["race"])
			s = CDTL2:GetSpellData(spellID)
			if s then
				s["icon"] = icon
				s["lane"] = CDTL2.db.profile.global["petSpells"]["defaultLane"]
				s["barFrame"] = CDTL2.db.profile.global["petSpells"]["defaultBar"]
				s["readyFrame"] = CDTL2.db.profile.global["petSpells"]["defaultReady"]
				
				--s["enabled"] = CDTL2.db.profile.global["tracking"]["showPetSpellsDefault"]
				s["enabled"] = CDTL2.db.profile.global["petSpells"]["showByDefault"]
				s["highlight"] = false
				s["pinned"] = false
				
				s["usedBy"] = { CDTL2.player["guid"] }
				
				local link, _ = GetSpellLink(spellID)
				s["link"] = link
				
				--CDTL2:Print("ADDING: "..s["id"].." - "..s["name"].." - "..s["icon"])
				table.insert(CDTL2.db.profile.tables["petSpells"], s)
				
				--if CDTL2.db.profile.global["tracking"]["enablePetSpells"] then
				if CDTL2.db.profile.global["petSpells"]["enabled"] then
					CDTL2:CreateCooldown(CDTL2:GetUID(),"petSpells" , s)
				end
			end
		end
	end
end

