--[[
	Cooldown Timeline, Vreenak (US-Remulos)
	https://www.curseforge.com/wow/addons/cooldown-timeline-2
]]--

local private = {}

function CDTL2:GetAllSpellData(class, race)
	--CDTL2:Print("STARTING SPELL DATA...")

	local d = {}
	
	for _, spell in pairs(private.GetRacialData()) do
		if spell["race"] == race then
			table.insert(d, spell)
			--CDTL2:Print("    RACIAL ADDED: "..spell["id"].." - "..spell["name"].." - "..spell["rank"])
		end
	end
	
	for _, spell in pairs(private.GetClassData(class)) do
		table.insert(d, spell)
		--CDTL2:Print("    SPELL ADDED: "..spell["id"].." - "..spell["name"].." - "..spell["rank"])
	end
	
	if class == "HUNTER" or class == "WARLOCK" then
		for _, spell in pairs(private.GetPetData(class)) do
			table.insert(d, spell)
			--CDTL2:Print("    PETSPELL ADDED: "..spell["id"].." - "..spell["name"].." - "..spell["rank"])
		end
	end
	
	--CDTL2:Print("FINISHED SPELL DATA")
	
	return d
end

--[[function CDTL2:GetSpellData(id, class, race)
	for _, spell in pairs(GetRacialData()) do
		if spell["id"] == id and spell["race"] == race then
			--CDTL2:Print("Found Spell: "..tostring(spell["name"]))
			return spell
		end
	end
	
	for _, spell in pairs(GetClassData(class)) do
		if spell["id"] == id then
			--CDTL2:Print("Found Spell: "..tostring(spell["name"]))
			return spell
		end
	end
	
	if class == "HUNTER" or class == "WARLOCK" then
		for _, spell in pairs(GetPetData(class)) do
			if spell["id"] == id then
				--CDTL2:Print("Found Spell: "..tostring(spell["name"]))
				return spell
			end
		end
	end
	
	return nil
end]]--

function CDTL2:GetSpellData(id)
	for _, spell in pairs(CDTL2.spellData) do
		--CDTL2:Print("Comparing Spell: "..tostring(spell["name"]))
		if spell["id"] == id then
			return spell
		end
	end
end

function CDTL2:ScanSpellData(class)
	for _, spell in pairs(private.GetClassData(class)) do
		local baseCD, _ = GetSpellBaseCooldown(spell["id"])
		
		--CDTL2:Print(spell["id"]..",,"..baseCD)
	end
	
	if class == "HUNTER" or class == "WARLOCK" then
		for _, pspell in pairs(private.GetPetData(class)) do
			local pbaseCD, _ = GetSpellBaseCooldown(pspell["id"])
						
			--CDTL2:Print(pspell["id"]..",,"..pbaseCD)
		end
	end
end

-- STRUCTURES
	--[[
	cooldowns = {
		id,
		name,
		rank,
		icon,
		oaf,
		enabled,
		type,
		lane,
		barFrame,
		highlight,
		
	}
	]]--

-- DEFAULTS

-- RACIALS
private.GetRacialData = function()
	local d = {}
	
	table.insert(d, { id = 7744, name = "Will of the Forsaken", race = "Undead", rank = "" } )
	table.insert(d, { id = 20549, name = "War Stomp", race = "Tauren", rank = "" } )
	table.insert(d, { id = 20554, name = "Berserking", race = "Troll", rank = "" } )
	table.insert(d, { id = 20572, name = "Blood Fury", race = "Orc", rank = "" } )
	table.insert(d, { id = 20577, name = "Cannibalize", race = "Undead", rank = "" } )
	table.insert(d, { id = 20580, name = "Shadowmeld", race = "Nightelf", rank = "", oaf = true } )
	table.insert(d, { id = 20589, name = "Escape Artist", race = "Gnome", rank = "" } )
	table.insert(d, { id = 20594, name = "Stoneform", race = "Dwarf", rank = "" } )
	table.insert(d, { id = 20600, name = "Perception", race = "Human", rank = "" } )
	table.insert(d, { id = 25046, name = "Arcane Torrent", race = "Bloodelf", rank = "" } )
	table.insert(d, { id = 26296, name = "Berserking", race = "Troll", rank = "" } )
	table.insert(d, { id = 26297, name = "Berserking", race = "Troll", rank = "" } )
	table.insert(d, { id = 28730, name = "Arcane Torrent", race = "Bloodelf", rank = "" } )
	table.insert(d, { id = 28734, name = "Mana Tap", race = "Bloodelf", rank = "" } )
	table.insert(d, { id = 28880, name = "Gift of the Naaru", race = "Draenei", rank = "" } )
	table.insert(d, { id = 33697, name = "Blood Fury", race = "Orc", rank = "" } )
	table.insert(d, { id = 33702, name = "Blood Fury", race = "Orc", rank = "" } )
	
	return d
end

-- CLASS
private.GetClassData = function(class)
	local d = {}
	
	-- Druid
	if class == "DRUID" then		
		-- MAIN SPELLS
		table.insert(d, { id = 22812, name = "Barkskin", rank = "", bCD = 60000 } )
		table.insert(d, { id = 5211, name = "Bash", rank = "1", bCD = 60000 } )
		table.insert(d, { id = 6798, name = "Bash", rank = "2", bCD = 60000 } )
		table.insert(d, { id = 8983, name = "Bash", rank = "3", bCD = 60000 } )
		table.insert(d, { id = 5209, name = "Challenging Roar", rank = "", bCD = 600000 } )
		table.insert(d, { id = 8998, name = "Cower", rank = "1", bCD = 10000 } )
		table.insert(d, { id = 9000, name = "Cower", rank = "2", bCD = 10000 } )
		table.insert(d, { id = 9892, name = "Cower", rank = "3", bCD = 10000 } )
		table.insert(d, { id = 31709, name = "Cower", rank = "4", bCD = 10000 } )
		table.insert(d, { id = 27004, name = "Cower", rank = "5", bCD = 10000 } )
		table.insert(d, { id = 1850, name = "Dash", rank = "1", bCD = 300000 } )
		table.insert(d, { id = 9821, name = "Dash", rank = "2", bCD = 300000 } )
		table.insert(d, { id = 33357, name = "Dash", rank = "3", bCD = 300000 } )
		table.insert(d, { id = 5229, name = "Enrage", rank = "", bCD = 60000 } )
		table.insert(d, { id = 22842, name = "Frenzied Regeneration", rank = "1", bCD = 180000 } )
		table.insert(d, { id = 22895, name = "Frenzied Regeneration", rank = "2", bCD = 180000 } )
		table.insert(d, { id = 22896, name = "Frenzied Regeneration", rank = "3", bCD = 180000 } )
		table.insert(d, { id = 26999, name = "Frenzied Regeneration", rank = "4", bCD = 180000 } )
		table.insert(d, { id = 6795, name = "Growl", rank = "", bCD = 10000 } )
		table.insert(d, { id = 16914, name = "Hurricane", rank = "1", bCD = 60000 } )
		table.insert(d, { id = 17401, name = "Hurricane", rank = "2", bCD = 60000 } )
		table.insert(d, { id = 17402, name = "Hurricane", rank = "3", bCD = 60000 } )
		table.insert(d, { id = 27012, name = "Hurricane", rank = "4", bCD = 60000 } )
		table.insert(d, { id = 29166, name = "Innervate", rank = "", bCD = 360000 } )
		table.insert(d, { id = 22570, name = "Maim", rank = "1", bCD = 10000 } )
		table.insert(d, { id = 33878, name = "Mangle (Bear)", rank = "1", bCD = 6000 } )
		table.insert(d, { id = 33986, name = "Mangle (Bear)", rank = "2", bCD = 6000 } )
		table.insert(d, { id = 33987, name = "Mangle (Bear)", rank = "3", bCD = 6000 } )
		table.insert(d, { id = 5215, name = "Prowl", rank = "1", bCD = 10000, oaf = true } )
		table.insert(d, { id = 6783, name = "Prowl", rank = "2", bCD = 10000, oaf = true } )
		table.insert(d, { id = 9913, name = "Prowl", rank = "3", bCD = 10000, oaf = true } )
		table.insert(d, { id = 20484, name = "Rebirth", rank = "1", bCD = 1200000 } )
		table.insert(d, { id = 20739, name = "Rebirth", rank = "2", bCD = 1200000 } )
		table.insert(d, { id = 20742, name = "Rebirth", rank = "3", bCD = 1200000 } )
		table.insert(d, { id = 20747, name = "Rebirth", rank = "4", bCD = 1200000 } )
		table.insert(d, { id = 20748, name = "Rebirth", rank = "5", bCD = 1200000 } )
		table.insert(d, { id = 26994, name = "Rebirth", rank = "6", bCD = 1200000 } )
		table.insert(d, { id = 5217, name = "Tiger's Fury", rank = "1", bCD = 1000 } )
		table.insert(d, { id = 6793, name = "Tiger's Fury", rank = "2", bCD = 1000 } )
		table.insert(d, { id = 9845, name = "Tiger's Fury", rank = "3", bCD = 1000 } )
		table.insert(d, { id = 9846, name = "Tiger's Fury", rank = "4", bCD = 1000 } )
		table.insert(d, { id = 740, name = "Tranquility", rank = "1", bCD = 600000 } )
		table.insert(d, { id = 8918, name = "Tranquility", rank = "2", bCD = 600000 } )
		table.insert(d, { id = 9862, name = "Tranquility", rank = "3", bCD = 600000 } )
		table.insert(d, { id = 9863, name = "Tranquility", rank = "4", bCD = 600000 } )
		table.insert(d, { id = 26983, name = "Tranquility", rank = "5", bCD = 600000 } )
		
		-- TALENT SPELLS
		table.insert(d, { id = 16857, name = "Faerie Fire (Feral)", rank = "1", bCD = 6000 } )
		table.insert(d, { id = 17390, name = "Faerie Fire (Feral)", rank = "2", bCD = 6000 } )
		table.insert(d, { id = 17391, name = "Faerie Fire (Feral)", rank = "3", bCD = 6000 } )
		table.insert(d, { id = 17392, name = "Faerie Fire (Feral)", rank = "4", bCD = 6000 } )
		table.insert(d, { id = 27011, name = "Faerie Fire (Feral)", rank = "5", bCD = 6000 } )
		table.insert(d, { id = 16979, name = "Feral Charge", rank = "", bCD = 15000 } )
		table.insert(d, { id = 33831, name = "Force of Nature", rank = "", bCD = 180000 } )
		table.insert(d, { id = 16689, name = "Nature's Grasp", rank = "1", bCD = 60000 } )
		table.insert(d, { id = 16810, name = "Nature's Grasp", rank = "2", bCD = 60000 } )
		table.insert(d, { id = 16811, name = "Nature's Grasp", rank = "3", bCD = 60000 } )
		table.insert(d, { id = 16812, name = "Nature's Grasp", rank = "4", bCD = 60000 } )
		table.insert(d, { id = 16813, name = "Nature's Grasp", rank = "5", bCD = 60000 } )
		table.insert(d, { id = 17329, name = "Nature's Grasp", rank = "6", bCD = 60000 } )
		table.insert(d, { id = 27009, name = "Nature's Grasp", rank = "7", bCD = 60000 } )
		table.insert(d, { id = 17116, name = "Nature's Swiftness", rank = "", bCD = 180000, oaf = true } )
		table.insert(d, { id = 18562, name = "Swiftmend", rank = "", bCD = 15000 } )
	end
	
	-- Hunter
	if class == "HUNTER" then		
		-- MAIN SPELLS
		table.insert(d, { id = 3044, name = "Arcane Shot", rank = "1", bCD = 6000 } )
		table.insert(d, { id = 14281, name = "Arcane Shot", rank = "2", bCD = 6000 } )
		table.insert(d, { id = 14282, name = "Arcane Shot", rank = "3", bCD = 6000 } )
		table.insert(d, { id = 14283, name = "Arcane Shot", rank = "4", bCD = 6000 } )
		table.insert(d, { id = 14284, name = "Arcane Shot", rank = "5", bCD = 6000 } )
		table.insert(d, { id = 14285, name = "Arcane Shot", rank = "6", bCD = 6000 } )
		table.insert(d, { id = 14286, name = "Arcane Shot", rank = "7", bCD = 6000 } )
		table.insert(d, { id = 14287, name = "Arcane Shot", rank = "8", bCD = 6000 } )
		table.insert(d, { id = 27019, name = "Arcane Shot", rank = "9", bCD = 6000 } )
		table.insert(d, { id = 5116, name = "Concussive Shot", rank = "", bCD = 12000 } )
		table.insert(d, { id = 781, name = "Disengage", rank = "1", bCD = 5000 } )
		table.insert(d, { id = 14272, name = "Disengage", rank = "2", bCD = 5000 } )
		table.insert(d, { id = 14273, name = "Disengage", rank = "3", bCD = 5000 } )
		table.insert(d, { id = 27015, name = "Disengage", rank = "4", bCD = 5000 } )
		table.insert(d, { id = 20736, name = "Distracting Shot", rank = "1", bCD = 8000 } )
		table.insert(d, { id = 14274, name = "Distracting Shot", rank = "2", bCD = 8000 } )
		table.insert(d, { id = 15629, name = "Distracting Shot", rank = "3", bCD = 8000 } )
		table.insert(d, { id = 15630, name = "Distracting Shot", rank = "4", bCD = 8000 } )
		table.insert(d, { id = 15631, name = "Distracting Shot", rank = "5", bCD = 8000 } )
		table.insert(d, { id = 15632, name = "Distracting Shot", rank = "6", bCD = 8000 } )
		table.insert(d, { id = 27020, name = "Distracting Shot", rank = "7", bCD = 8000 } )
		table.insert(d, { id = 13813, name = "Explosive Trap", rank = "1", bCD = 30000 } )
		table.insert(d, { id = 14316, name = "Explosive Trap", rank = "2", bCD = 30000 } )
		table.insert(d, { id = 14317, name = "Explosive Trap", rank = "3", bCD = 30000 } )
		table.insert(d, { id = 27025, name = "Explosive Trap", rank = "4", bCD = 30000 } )
		table.insert(d, { id = 5384, name = "Feign Death", rank = "", bCD = 30000, oaf = true } )
		table.insert(d, { id = 1543, name = "Flare", rank = "", bCD = 20000 } )
		table.insert(d, { id = 1499, name = "Freezing Trap", rank = "1", bCD = 30000 } )
		table.insert(d, { id = 14310, name = "Freezing Trap", rank = "2", bCD = 30000 } )
		table.insert(d, { id = 14311, name = "Freezing Trap", rank = "3", bCD = 30000 } )
		table.insert(d, { id = 13809, name = "Frost Trap", rank = "", bCD = 30000 } )
		table.insert(d, { id = 13795, name = "Immolation Trap", rank = "1", bCD = 30000 } )
		table.insert(d, { id = 14302, name = "Immolation Trap", rank = "2", bCD = 30000 } )
		table.insert(d, { id = 14303, name = "Immolation Trap", rank = "3", bCD = 30000 } )
		table.insert(d, { id = 14304, name = "Immolation Trap", rank = "4", bCD = 30000 } )
		table.insert(d, { id = 14305, name = "Immolation Trap", rank = "5", bCD = 30000 } )
		table.insert(d, { id = 27023, name = "Immolation Trap", rank = "6", bCD = 30000 } )
		table.insert(d, { id = 34026, name = "Kill Command", rank = "", bCD = 5000 } )
		table.insert(d, { id = 34477, name = "Misdirection", rank = "", bCD = 120000 } )
		table.insert(d, { id = 1495, name = "Mongoose Bite", rank = "1", bCD = 5000 } )
		table.insert(d, { id = 14269, name = "Mongoose Bite", rank = "2", bCD = 5000 } )
		table.insert(d, { id = 14270, name = "Mongoose Bite", rank = "3", bCD = 5000 } )
		table.insert(d, { id = 14271, name = "Mongoose Bite", rank = "4", bCD = 5000 } )
		table.insert(d, { id = 36916, name = "Mongoose Bite", rank = "5", bCD = 5000 } )
		table.insert(d, { id = 2643, name = "Multi-Shot", rank = "1", bCD = 10000 } )
		table.insert(d, { id = 14288, name = "Multi-Shot", rank = "2", bCD = 10000 } )
		table.insert(d, { id = 14289, name = "Multi-Shot", rank = "3", bCD = 10000 } )
		table.insert(d, { id = 14290, name = "Multi-Shot", rank = "4", bCD = 10000 } )
		table.insert(d, { id = 25294, name = "Multi-Shot", rank = "5", bCD = 10000 } )
		table.insert(d, { id = 27021, name = "Multi-Shot", rank = "6", bCD = 10000 } )
		table.insert(d, { id = 3045, name = "Rapid Fire", rank = "", bCD = 300000 } )
		table.insert(d, { id = 2973, name = "Raptor Strike", rank = "1", bCD = 6000 } )
		table.insert(d, { id = 14260, name = "Raptor Strike", rank = "2", bCD = 6000 } )
		table.insert(d, { id = 14261, name = "Raptor Strike", rank = "3", bCD = 6000 } )
		table.insert(d, { id = 14262, name = "Raptor Strike", rank = "4", bCD = 6000 } )
		table.insert(d, { id = 14263, name = "Raptor Strike", rank = "5", bCD = 6000 } )
		table.insert(d, { id = 14264, name = "Raptor Strike", rank = "6", bCD = 6000 } )
		table.insert(d, { id = 14265, name = "Raptor Strike", rank = "7", bCD = 6000 } )
		table.insert(d, { id = 14266, name = "Raptor Strike", rank = "8", bCD = 6000 } )
		table.insert(d, { id = 27014, name = "Raptor Strike", rank = "9", bCD = 6000 } )
		table.insert(d, { id = 1513, name = "Scare Beast", rank = "1", bCD = 30000 } )
		table.insert(d, { id = 14326, name = "Scare Beast", rank = "2", bCD = 30000 } )
		table.insert(d, { id = 14327, name = "Scare Beast", rank = "3", bCD = 30000 } )
		table.insert(d, { id = 34600, name = "Snake Trap", rank = "", bCD = 30000 } )
		table.insert(d, { id = 19801, name = "Tranquilizing Shot", rank = "", bCD = 20000 } )
		table.insert(d, { id = 3034, name = "Viper Sting", rank = "1", bCD = 15000 } )
		table.insert(d, { id = 14279, name = "Viper Sting", rank = "2", bCD = 15000 } )
		table.insert(d, { id = 14280, name = "Viper Sting", rank = "3", bCD = 15000 } )
		table.insert(d, { id = 27018, name = "Viper Sting", rank = "4", bCD = 15000 } )
		table.insert(d, { id = 1510, name = "Volley", rank = "1", bCD = 60000 } )
		table.insert(d, { id = 14294, name = "Volley", rank = "2", bCD = 60000 } )
		table.insert(d, { id = 14295, name = "Volley", rank = "3", bCD = 60000 } )
		table.insert(d, { id = 27022, name = "Volley", rank = "4", bCD = 60000 } )
		
		-- TALENT SPELLS
		table.insert(d, { id = 19434, name = "Aimed Shot", rank = "1", bCD = 6000 } )
		table.insert(d, { id = 20900, name = "Aimed Shot", rank = "2", bCD = 6000 } )
		table.insert(d, { id = 20901, name = "Aimed Shot", rank = "3", bCD = 6000 } )
		table.insert(d, { id = 20902, name = "Aimed Shot", rank = "4", bCD = 6000 } )
		table.insert(d, { id = 20903, name = "Aimed Shot", rank = "5", bCD = 6000 } )
		table.insert(d, { id = 20904, name = "Aimed Shot", rank = "6", bCD = 6000 } )
		table.insert(d, { id = 27065, name = "Aimed Shot", rank = "7", bCD = 6000 } )
		table.insert(d, { id = 19574, name = "Bestial Wrath", rank = "", bCD = 120000 } )
		table.insert(d, { id = 19306, name = "Counterattack", rank = "1", bCD = 5000 } )
		table.insert(d, { id = 20909, name = "Counterattack", rank = "2", bCD = 5000 } )
		table.insert(d, { id = 20910, name = "Counterattack", rank = "3", bCD = 5000 } )
		table.insert(d, { id = 27067, name = "Counterattack", rank = "4", bCD = 5000 } )
		table.insert(d, { id = 19263, name = "Deterrence", rank = "", bCD = 300000 } )
		table.insert(d, { id = 19577, name = "Intimidation", rank = "", bCD = 60000 } )
		table.insert(d, { id = 23989, name = "Readiness", rank = "", bCD = 300000 } )
		table.insert(d, { id = 19503, name = "Scatter Shot", rank = "", bCD = 30000 } )
		table.insert(d, { id = 34490, name = "Silencing Shot", rank = "", bCD = 20000 } )
		table.insert(d, { id = 19386, name = "Wyvern Sting", rank = "1", bCD = 120000 } )
		table.insert(d, { id = 24132, name = "Wyvern Sting", rank = "2", bCD = 120000 } )
		table.insert(d, { id = 24133, name = "Wyvern Sting", rank = "3", bCD = 120000 } )
		table.insert(d, { id = 27068, name = "Wyvern Sting", rank = "4", bCD = 120000 } )
	end
	
	-- Mage
	if class == "MAGE" then		
		-- MAIN SPELLS
		table.insert(d, { id = 1953, name = "Blink", rank = "", bCD = 15000 } )
		table.insert(d, { id = 120, name = "Cone of Cold", rank = "1", bCD = 10000 } )
		table.insert(d, { id = 8492, name = "Cone of Cold", rank = "2", bCD = 10000 } )
		table.insert(d, { id = 10159, name = "Cone of Cold", rank = "3", bCD = 10000 } )
		table.insert(d, { id = 10160, name = "Cone of Cold", rank = "4", bCD = 10000 } )
		table.insert(d, { id = 10161, name = "Cone of Cold", rank = "5", bCD = 10000 } )
		table.insert(d, { id = 27087, name = "Cone of Cold", rank = "6", bCD = 10000 } )
		table.insert(d, { id = 2139, name = "Counterspell", rank = "", bCD = 24000 } )
		table.insert(d, { id = 12051, name = "Evocation", rank = "", bCD = 480000 } )
		table.insert(d, { id = 2136, name = "Fire Blast", rank = "1", bCD = 8000 } )
		table.insert(d, { id = 2137, name = "Fire Blast", rank = "2", bCD = 8000 } )
		table.insert(d, { id = 2138, name = "Fire Blast", rank = "3", bCD = 8000 } )
		table.insert(d, { id = 8412, name = "Fire Blast", rank = "4", bCD = 8000 } )
		table.insert(d, { id = 8413, name = "Fire Blast", rank = "5", bCD = 8000 } )
		table.insert(d, { id = 10197, name = "Fire Blast", rank = "6", bCD = 8000 } )
		table.insert(d, { id = 10199, name = "Fire Blast", rank = "7", bCD = 8000 } )
		table.insert(d, { id = 27078, name = "Fire Blast", rank = "8", bCD = 8000 } )
		table.insert(d, { id = 27079, name = "Fire Blast", rank = "9", bCD = 8000 } )
		table.insert(d, { id = 543, name = "Fire Ward", rank = "1", bCD = 30000 } )
		table.insert(d, { id = 8457, name = "Fire Ward", rank = "2", bCD = 30000 } )
		table.insert(d, { id = 8458, name = "Fire Ward", rank = "3", bCD = 30000 } )
		table.insert(d, { id = 10223, name = "Fire Ward", rank = "4", bCD = 30000 } )
		table.insert(d, { id = 10225, name = "Fire Ward", rank = "5", bCD = 30000 } )
		table.insert(d, { id = 27128, name = "Fire Ward", rank = "6", bCD = 30000 } )
		table.insert(d, { id = 122, name = "Frost Nova", rank = "1", bCD = 25000 } )
		table.insert(d, { id = 865, name = "Frost Nova", rank = "2", bCD = 25000 } )
		table.insert(d, { id = 6131, name = "Frost Nova", rank = "3", bCD = 25000 } )
		table.insert(d, { id = 10230, name = "Frost Nova", rank = "4", bCD = 25000 } )
		table.insert(d, { id = 27088, name = "Frost Nova", rank = "5", bCD = 25000 } )
		table.insert(d, { id = 6143, name = "Frost Ward", rank = "1", bCD = 30000 } )
		table.insert(d, { id = 8461, name = "Frost Ward", rank = "2", bCD = 30000 } )
		table.insert(d, { id = 8462, name = "Frost Ward", rank = "3", bCD = 30000 } )
		table.insert(d, { id = 10177, name = "Frost Ward", rank = "4", bCD = 30000 } )
		table.insert(d, { id = 28609, name = "Frost Ward", rank = "5", bCD = 30000 } )
		table.insert(d, { id = 32796, name = "Frost Ward", rank = "6", bCD = 30000 } )
		table.insert(d, { id = 45438, name = "Ice Block", rank = "", bCD = 300000 } )
		table.insert(d, { id = 66, name = "Invisibility", rank = "", bCD = 300000 } )
		table.insert(d, { id = 11419, name = "Portal: Darnassus", rank = "", bCD = 60000 } )
		table.insert(d, { id = 32266, name = "Portal: Exodar", rank = "", bCD = 60000 } )
		table.insert(d, { id = 11416, name = "Portal: Ironforge", rank = "", bCD = 60000 } )
		table.insert(d, { id = 11417, name = "Portal: Orgrimmar", rank = "", bCD = 60000 } )
		table.insert(d, { id = 33691, name = "Portal: Shattrath", rank = "", bCD = 60000 } )
		table.insert(d, { id = 35717, name = "Portal: Shattrath", rank = "", bCD = 60000 } )
		table.insert(d, { id = 32267, name = "Portal: Silvermoon", rank = "", bCD = 60000 } )
		table.insert(d, { id = 49361, name = "Portal: Stonard", rank = "", bCD = 60000 } )
		table.insert(d, { id = 10059, name = "Portal: Stormwind", rank = "", bCD = 60000 } )
		table.insert(d, { id = 49360, name = "Portal: Theramore", rank = "", bCD = 60000 } )
		table.insert(d, { id = 11420, name = "Portal: Thunder Bluff", rank = "", bCD = 60000 } )
		table.insert(d, { id = 11418, name = "Portal: Undercity", rank = "", bCD = 60000 } )
		table.insert(d, { id = 43987, name = "Ritual of Refreshment", rank = "1", bCD = 300000, oaf = true } )
		
		-- TALENT SPELLS
		table.insert(d, { id = 12042, name = "Arcane Power", rank = "", bCD = 180000 } )
		table.insert(d, { id = 11113, name = "Blast Wave", rank = "1", bCD = 30000 } )
		table.insert(d, { id = 13018, name = "Blast Wave", rank = "2", bCD = 30000 } )
		table.insert(d, { id = 13019, name = "Blast Wave", rank = "3", bCD = 30000 } )
		table.insert(d, { id = 13020, name = "Blast Wave", rank = "4", bCD = 30000 } )
		table.insert(d, { id = 13021, name = "Blast Wave", rank = "5", bCD = 30000 } )
		table.insert(d, { id = 27133, name = "Blast Wave", rank = "6", bCD = 30000 } )
		table.insert(d, { id = 33933, name = "Blast Wave", rank = "7", bCD = 30000 } )
		table.insert(d, { id = 11958, name = "Cold Snap", rank = "", bCD = 480000 } )
		table.insert(d, { id = 11129, name = "Combustion", rank = "", bCD = 180000, oaf = true } )
		table.insert(d, { id = 31661, name = "Dragon's Breath", rank = "1", bCD = 20000 } )
		table.insert(d, { id = 33041, name = "Dragon's Breath", rank = "2", bCD = 20000 } )
		table.insert(d, { id = 33042, name = "Dragon's Breath", rank = "3", bCD = 20000 } )
		table.insert(d, { id = 33043, name = "Dragon's Breath", rank = "4", bCD = 20000 } )
		table.insert(d, { id = 11426, name = "Ice Barrier", rank = "1", bCD = 30000 } )
		table.insert(d, { id = 13031, name = "Ice Barrier", rank = "2", bCD = 30000 } )
		table.insert(d, { id = 13032, name = "Ice Barrier", rank = "3", bCD = 30000 } )
		table.insert(d, { id = 13033, name = "Ice Barrier", rank = "4", bCD = 30000 } )
		table.insert(d, { id = 27134, name = "Ice Barrier", rank = "5", bCD = 30000 } )
		table.insert(d, { id = 33405, name = "Ice Barrier", rank = "6", bCD = 30000 } )
		table.insert(d, { id = 12472, name = "Icy Veins", rank = "", bCD = 180000 } )
		table.insert(d, { id = 12043, name = "Presence of Mind", rank = "", bCD = 180000, oaf = true } )
		table.insert(d, { id = 31687, name = "Summon Water Elemental", rank = "", bCD = 180000 } )
	end
	
	-- Paladin
	if class == "PALADIN" then		
		-- MAIN SPELLS
		table.insert(d, { id = 31884, name = "Avenging Wrath", rank = "", bCD = 180000 } )
		table.insert(d, { id = 1044, name = "Blessing of Freedom", rank = "", bCD = 25000 } )
		table.insert(d, { id = 1022, name = "Blessing of Protection", rank = "1", bCD = 300000 } )
		table.insert(d, { id = 5599, name = "Blessing of Protection", rank = "2", bCD = 300000 } )
		table.insert(d, { id = 10278, name = "Blessing of Protection", rank = "3", bCD = 300000 } )
		table.insert(d, { id = 6940, name = "Blessing of Sacrifice", rank = "1", bCD = 30000 } )
		table.insert(d, { id = 20729, name = "Blessing of Sacrifice", rank = "2", bCD = 30000 } )
		table.insert(d, { id = 27147, name = "Blessing of Sacrifice", rank = "3", bCD = 30000 } )
		table.insert(d, { id = 27148, name = "Blessing of Sacrifice", rank = "4", bCD = 30000 } )
		table.insert(d, { id = 26573, name = "Consecration", rank = "1", bCD = 8000 } )
		table.insert(d, { id = 20116, name = "Consecration", rank = "2", bCD = 8000 } )
		table.insert(d, { id = 20922, name = "Consecration", rank = "3", bCD = 8000 } )
		table.insert(d, { id = 20923, name = "Consecration", rank = "4", bCD = 8000 } )
		table.insert(d, { id = 20924, name = "Consecration", rank = "5", bCD = 8000 } )
		table.insert(d, { id = 27173, name = "Consecration", rank = "6", bCD = 8000 } )
		table.insert(d, { id = 19752, name = "Divine Intervention", rank = "", bCD = 3600000 } )
		table.insert(d, { id = 498, name = "Divine Protection", rank = "1", bCD = 300000 } )
		table.insert(d, { id = 5573, name = "Divine Protection", rank = "2", bCD = 300000 } )
		table.insert(d, { id = 642, name = "Divine Shield", rank = "1", bCD = 300000 } )
		table.insert(d, { id = 1020, name = "Divine Shield", rank = "2", bCD = 300000 } )
		table.insert(d, { id = 879, name = "Exorcism", rank = "1", bCD = 15000 } )
		table.insert(d, { id = 5614, name = "Exorcism", rank = "2", bCD = 15000 } )
		table.insert(d, { id = 5615, name = "Exorcism", rank = "3", bCD = 15000 } )
		table.insert(d, { id = 10312, name = "Exorcism", rank = "4", bCD = 15000 } )
		table.insert(d, { id = 10313, name = "Exorcism", rank = "5", bCD = 15000 } )
		table.insert(d, { id = 10314, name = "Exorcism", rank = "6", bCD = 15000 } )
		table.insert(d, { id = 27138, name = "Exorcism", rank = "7", bCD = 15000 } )
		table.insert(d, { id = 853, name = "Hammer of Justice", rank = "1", bCD = 60000 } )
		table.insert(d, { id = 5588, name = "Hammer of Justice", rank = "2", bCD = 60000 } )
		table.insert(d, { id = 5589, name = "Hammer of Justice", rank = "3", bCD = 60000 } )
		table.insert(d, { id = 10308, name = "Hammer of Justice", rank = "4", bCD = 60000 } )
		table.insert(d, { id = 24275, name = "Hammer of Wrath", rank = "1", bCD = 6000 } )
		table.insert(d, { id = 24274, name = "Hammer of Wrath", rank = "2", bCD = 6000 } )
		table.insert(d, { id = 24239, name = "Hammer of Wrath", rank = "3", bCD = 6000 } )
		table.insert(d, { id = 27180, name = "Hammer of Wrath", rank = "4", bCD = 6000 } )
		table.insert(d, { id = 2812, name = "Holy Wrath", rank = "1", bCD = 60000 } )
		table.insert(d, { id = 10318, name = "Holy Wrath", rank = "2", bCD = 60000 } )
		table.insert(d, { id = 27139, name = "Holy Wrath", rank = "3", bCD = 60000 } )
		table.insert(d, { id = 20271, name = "Judgement", rank = "", bCD = 10000 } )
		table.insert(d, { id = 633, name = "Lay on Hands", rank = "1", bCD = 3600000 } )
		table.insert(d, { id = 2800, name = "Lay on Hands", rank = "2", bCD = 3600000 } )
		table.insert(d, { id = 10310, name = "Lay on Hands", rank = "3", bCD = 3600000 } )
		table.insert(d, { id = 27154, name = "Lay on Hands", rank = "4", bCD = 3600000 } )
		table.insert(d, { id = 31789, name = "Righteous Defense", rank = "", bCD = 15000 } )
		table.insert(d, { id = 10326, name = "Turn Evil", rank = "1", bCD = 30000 } )
		table.insert(d, { id = 2878, name = "Turn Undead", rank = "1", bCD = 30000 } )
		table.insert(d, { id = 5627, name = "Turn Undead", rank = "2", bCD = 30000 } )
	
		-- TALENT SPELLS
		table.insert(d, { id = 31935, name = "Avenger's Shield", rank = "1", bCD = 30000 } )
		table.insert(d, { id = 32699, name = "Avenger's Shield", rank = "2", bCD = 30000 } )
		table.insert(d, { id = 32700, name = "Avenger's Shield", rank = "3", bCD = 30000 } )
		table.insert(d, { id = 35395, name = "Crusader Strike", rank = "", bCD = 6000 } )
		table.insert(d, { id = 20216, name = "Divine Favor", rank = "", bCD = 120000, oaf = true } )
		table.insert(d, { id = 31842, name = "Divine Illumination", rank = "", bCD = 180000 } )
		table.insert(d, { id = 20925, name = "Holy Shield", rank = "1", bCD = 10000 } )
		table.insert(d, { id = 20927, name = "Holy Shield", rank = "2", bCD = 10000 } )
		table.insert(d, { id = 20928, name = "Holy Shield", rank = "3", bCD = 10000 } )
		table.insert(d, { id = 27179, name = "Holy Shield", rank = "4", bCD = 10000 } )
		table.insert(d, { id = 20473, name = "Holy Shock", rank = "1", bCD = 15000 } )
		table.insert(d, { id = 20929, name = "Holy Shock", rank = "2", bCD = 15000 } )
		table.insert(d, { id = 20930, name = "Holy Shock", rank = "3", bCD = 15000 } )
		table.insert(d, { id = 27174, name = "Holy Shock", rank = "4", bCD = 15000 } )
		table.insert(d, { id = 33072, name = "Holy Shock", rank = "5", bCD = 15000 } )
		table.insert(d, { id = 20066, name = "Repentance", rank = "", bCD = 60000 } )
	end
	
	-- Priest
	if class == "PRIEST" then		
		-- MAIN SPELLS
		table.insert(d, { id = 44041, name = "Chastise", rank = "1", bCD = 30000 } )
		table.insert(d, { id = 44043, name = "Chastise", rank = "2", bCD = 30000 } )
		table.insert(d, { id = 44044, name = "Chastise", rank = "3", bCD = 30000 } )
		table.insert(d, { id = 44045, name = "Chastise", rank = "4", bCD = 30000 } )
		table.insert(d, { id = 44046, name = "Chastise", rank = "5", bCD = 30000 } )
		table.insert(d, { id = 44047, name = "Chastise", rank = "6", bCD = 30000 } )
		table.insert(d, { id = 32676, name = "Consume Magic", rank = "", bCD = 120000 } )
		table.insert(d, { id = 13908, name = "Desperate Prayer", rank = "1", bCD = 600000 } )
		table.insert(d, { id = 19236, name = "Desperate Prayer", rank = "2", bCD = 600000 } )
		table.insert(d, { id = 19238, name = "Desperate Prayer", rank = "3", bCD = 600000 } )
		table.insert(d, { id = 19240, name = "Desperate Prayer", rank = "4", bCD = 600000 } )
		table.insert(d, { id = 19241, name = "Desperate Prayer", rank = "5", bCD = 600000 } )
		table.insert(d, { id = 19242, name = "Desperate Prayer", rank = "6", bCD = 600000 } )
		table.insert(d, { id = 19243, name = "Desperate Prayer", rank = "7", bCD = 600000 } )
		table.insert(d, { id = 25437, name = "Desperate Prayer", rank = "8", bCD = 600000 } )
		table.insert(d, { id = 2944, name = "Devouring Plague", rank = "1", bCD = 180000 } )
		table.insert(d, { id = 19276, name = "Devouring Plague", rank = "2", bCD = 180000 } )
		table.insert(d, { id = 19277, name = "Devouring Plague", rank = "3", bCD = 180000 } )
		table.insert(d, { id = 19278, name = "Devouring Plague", rank = "4", bCD = 180000 } )
		table.insert(d, { id = 19279, name = "Devouring Plague", rank = "5", bCD = 180000 } )
		table.insert(d, { id = 19280, name = "Devouring Plague", rank = "6", bCD = 180000 } )
		table.insert(d, { id = 25467, name = "Devouring Plague", rank = "7", bCD = 180000 } )
		table.insert(d, { id = 2651, name = "Elune's Grace", rank = "", bCD = 180000 } )
		table.insert(d, { id = 586, name = "Fade", rank = "1", bCD = 30000 } )
		table.insert(d, { id = 9578, name = "Fade", rank = "2", bCD = 30000 } )
		table.insert(d, { id = 9579, name = "Fade", rank = "3", bCD = 30000 } )
		table.insert(d, { id = 9592, name = "Fade", rank = "4", bCD = 30000 } )
		table.insert(d, { id = 10941, name = "Fade", rank = "5", bCD = 30000 } )
		table.insert(d, { id = 10942, name = "Fade", rank = "6", bCD = 30000 } )
		table.insert(d, { id = 25429, name = "Fade", rank = "7", bCD = 30000 } )
		table.insert(d, { id = 6346, name = "Fear Ward", rank = "", bCD = 180000 } )
		table.insert(d, { id = 13896, name = "Feedback", rank = "1", bCD = 180000 } )
		table.insert(d, { id = 19271, name = "Feedback", rank = "2", bCD = 180000 } )
		table.insert(d, { id = 19273, name = "Feedback", rank = "3", bCD = 180000 } )
		table.insert(d, { id = 19274, name = "Feedback", rank = "4", bCD = 180000 } )
		table.insert(d, { id = 19275, name = "Feedback", rank = "5", bCD = 180000 } )
		table.insert(d, { id = 25441, name = "Feedback", rank = "6", bCD = 180000 } )
		table.insert(d, { id = 8092, name = "Mind Blast", rank = "1", bCD = 8000 } )
		table.insert(d, { id = 8102, name = "Mind Blast", rank = "2", bCD = 8000 } )
		table.insert(d, { id = 8103, name = "Mind Blast", rank = "3", bCD = 8000 } )
		table.insert(d, { id = 8104, name = "Mind Blast", rank = "4", bCD = 8000 } )
		table.insert(d, { id = 8105, name = "Mind Blast", rank = "5", bCD = 8000 } )
		table.insert(d, { id = 8106, name = "Mind Blast", rank = "6", bCD = 8000 } )
		table.insert(d, { id = 10945, name = "Mind Blast", rank = "7", bCD = 8000 } )
		table.insert(d, { id = 10946, name = "Mind Blast", rank = "8", bCD = 8000 } )
		table.insert(d, { id = 10947, name = "Mind Blast", rank = "9", bCD = 8000 } )
		table.insert(d, { id = 25372, name = "Mind Blast", rank = "10", bCD = 8000 } )
		table.insert(d, { id = 25375, name = "Mind Blast", rank = "11", bCD = 8000 } )
		table.insert(d, { id = 17, name = "Power Word: Shield", rank = "1", bCD = 4000 } )
		table.insert(d, { id = 592, name = "Power Word: Shield", rank = "2", bCD = 4000 } )
		table.insert(d, { id = 600, name = "Power Word: Shield", rank = "3", bCD = 4000 } )
		table.insert(d, { id = 3747, name = "Power Word: Shield", rank = "4", bCD = 4000 } )
		table.insert(d, { id = 6065, name = "Power Word: Shield", rank = "5", bCD = 4000 } )
		table.insert(d, { id = 6066, name = "Power Word: Shield", rank = "6", bCD = 4000 } )
		table.insert(d, { id = 10898, name = "Power Word: Shield", rank = "7", bCD = 4000 } )
		table.insert(d, { id = 10899, name = "Power Word: Shield", rank = "8", bCD = 4000 } )
		table.insert(d, { id = 10900, name = "Power Word: Shield", rank = "9", bCD = 4000 } )
		table.insert(d, { id = 10901, name = "Power Word: Shield", rank = "10", bCD = 4000 } )
		table.insert(d, { id = 25217, name = "Power Word: Shield", rank = "11", bCD = 4000 } )
		table.insert(d, { id = 25218, name = "Power Word: Shield", rank = "12", bCD = 4000 } )
		table.insert(d, { id = 33076, name = "Prayer of Mending", rank = "1", bCD = 10000 } )
		table.insert(d, { id = 8122, name = "Psychic Scream", rank = "1", bCD = 30000 } )
		table.insert(d, { id = 8124, name = "Psychic Scream", rank = "2", bCD = 30000 } )
		table.insert(d, { id = 10888, name = "Psychic Scream", rank = "3", bCD = 30000 } )
		table.insert(d, { id = 10890, name = "Psychic Scream", rank = "4", bCD = 30000 } )
		table.insert(d, { id = 32379, name = "Shadow Word: Death", rank = "1", bCD = 12000 } )
		table.insert(d, { id = 32996, name = "Shadow Word: Death", rank = "2", bCD = 12000 } )
		table.insert(d, { id = 34433, name = "Shadowfiend", rank = "1", bCD = 300000 } )
		table.insert(d, { id = 10797, name = "Starshards", rank = "1", bCD = 30000 } )
		table.insert(d, { id = 19296, name = "Starshards", rank = "2", bCD = 30000 } )
		table.insert(d, { id = 19299, name = "Starshards", rank = "3", bCD = 30000 } )
		table.insert(d, { id = 19302, name = "Starshards", rank = "4", bCD = 30000 } )
		table.insert(d, { id = 19303, name = "Starshards", rank = "5", bCD = 30000 } )
		table.insert(d, { id = 19304, name = "Starshards", rank = "6", bCD = 30000 } )
		table.insert(d, { id = 19305, name = "Starshards", rank = "7", bCD = 30000 } )
		table.insert(d, { id = 25446, name = "Starshards", rank = "8", bCD = 30000 } )
		table.insert(d, { id = 32548, name = "Symbol of Hope", rank = "", bCD = 300000 } )
	
		-- TALENT SPELLS
		table.insert(d, { id = 14751, name = "Inner Focus", rank = "", bCD = 180000, oaf = true } )
		table.insert(d, { id = 724, name = "Lightwell", rank = "1", bCD = 360000 } )
		table.insert(d, { id = 27870, name = "Lightwell", rank = "2", bCD = 360000 } )
		table.insert(d, { id = 27871, name = "Lightwell", rank = "3", bCD = 360000 } )
		table.insert(d, { id = 28275, name = "Lightwell", rank = "4", bCD = 360000 } )
		table.insert(d, { id = 33206, name = "Pain Suppression", rank = "", bCD = 120000 } )
		table.insert(d, { id = 10060, name = "Power Infusion", rank = "", bCD = 180000 } )
		table.insert(d, { id = 15473, name = "Shadowform", rank = "", bCD = 1500, oaf = true } )
		table.insert(d, { id = 15487, name = "Silence", rank = "", bCD = 45000 } )
		table.insert(d, { id = 15286, name = "Vampiric Embrace", rank = "", bCD = 10000 } )
	end
	
	-- Rogue
	if class == "ROGUE" then		
		-- MAIN SPELLS
		table.insert(d, { id = 2094, name = "Blind", rank = "", bCD = 180000 } )
		table.insert(d, { id = 31224, name = "Cloak of Shadows", rank = "", bCD = 60000 } )
		table.insert(d, { id = 1725, name = "Distract", rank = "", bCD = 30000 } )
		table.insert(d, { id = 5277, name = "Evasion", rank = "1", bCD = 300000 } )
		table.insert(d, { id = 26669, name = "Evasion", rank = "2", bCD = 300000 } )
		table.insert(d, { id = 1966, name = "Feint", rank = "1", bCD = 10000 } )
		table.insert(d, { id = 6768, name = "Feint", rank = "2", bCD = 10000 } )
		table.insert(d, { id = 8637, name = "Feint", rank = "3", bCD = 10000 } )
		table.insert(d, { id = 11303, name = "Feint", rank = "4", bCD = 10000 } )
		table.insert(d, { id = 25302, name = "Feint", rank = "5", bCD = 10000 } )
		table.insert(d, { id = 27448, name = "Feint", rank = "6", bCD = 10000 } )
		table.insert(d, { id = 1776, name = "Gouge", rank = "1", bCD = 10000 } )
		table.insert(d, { id = 1777, name = "Gouge", rank = "2", bCD = 10000 } )
		table.insert(d, { id = 8629, name = "Gouge", rank = "3", bCD = 10000 } )
		table.insert(d, { id = 11285, name = "Gouge", rank = "4", bCD = 10000 } )
		table.insert(d, { id = 11286, name = "Gouge", rank = "5", bCD = 10000 } )
		table.insert(d, { id = 38764, name = "Gouge", rank = "6", bCD = 10000 } )
		table.insert(d, { id = 1766, name = "Kick", rank = "1", bCD = 10000 } )
		table.insert(d, { id = 1767, name = "Kick", rank = "2", bCD = 10000 } )
		table.insert(d, { id = 1768, name = "Kick", rank = "3", bCD = 10000 } )
		table.insert(d, { id = 1769, name = "Kick", rank = "4", bCD = 10000 } )
		table.insert(d, { id = 38768, name = "Kick", rank = "5", bCD = 10000 } )
		table.insert(d, { id = 408, name = "Kidney Shot", rank = "1", bCD = 20000 } )
		table.insert(d, { id = 8643, name = "Kidney Shot", rank = "2", bCD = 20000 } )
		table.insert(d, { id = 2983, name = "Sprint", rank = "1", bCD = 300000 } )
		table.insert(d, { id = 8696, name = "Sprint", rank = "2", bCD = 300000 } )
		table.insert(d, { id = 11305, name = "Sprint", rank = "3", bCD = 300000 } )
		table.insert(d, { id = 1784, name = "Stealth", rank = "1", bCD = 10000, oaf = true } )
		table.insert(d, { id = 1785, name = "Stealth", rank = "2", bCD = 10000, oaf = true } )
		table.insert(d, { id = 1786, name = "Stealth", rank = "3", bCD = 10000, oaf = true } )
		table.insert(d, { id = 1787, name = "Stealth", rank = "4", bCD = 10000, oaf = true } )
		table.insert(d, { id = 1856, name = "Vanish", rank = "1", bCD = 300000 } )
		table.insert(d, { id = 1857, name = "Vanish", rank = "2", bCD = 300000 } )
		table.insert(d, { id = 26889, name = "Vanish", rank = "3", bCD = 300000 } )
	
		-- TALENT SPELLS
		table.insert(d, { id = 13750, name = "Adrenaline Rush", rank = "", bCD = 300000 } )
		table.insert(d, { id = 13877, name = "Blade Flurry", rank = "", bCD = 120000 } )
		table.insert(d, { id = 14177, name = "Cold Blood", rank = "", bCD = 180000, oaf = true } )
		table.insert(d, { id = 14278, name = "Ghostly Strike", rank = "", bCD = 20000 } )
		table.insert(d, { id = 14183, name = "Premeditation", rank = "", bCD = 120000 } )
		table.insert(d, { id = 14185, name = "Preparation", rank = "", bCD = 600000 } )
		table.insert(d, { id = 14251, name = "Riposte", rank = "", bCD = 6000 } )
		table.insert(d, { id = 36554, name = "Shadowstep", rank = "", bCD = 30000 } )

	end
	
	-- Shaman
	if class == "SHAMAN" then		
		-- MAIN SPELLS
		table.insert(d, { id = 556, name = "Astral Recall", rank = "", bCD = 900000 } )
		table.insert(d, { id = 2825, name = "Bloodlust", rank = "1", bCD = 600000 } )
		table.insert(d, { id = 421, name = "Chain Lightning", rank = "1", bCD = 6000 } )
		table.insert(d, { id = 930, name = "Chain Lightning", rank = "2", bCD = 6000 } )
		table.insert(d, { id = 2860, name = "Chain Lightning", rank = "3", bCD = 6000 } )
		table.insert(d, { id = 10605, name = "Chain Lightning", rank = "4", bCD = 6000 } )
		table.insert(d, { id = 25439, name = "Chain Lightning", rank = "5", bCD = 6000 } )
		table.insert(d, { id = 25442, name = "Chain Lightning", rank = "6", bCD = 6000 } )
		table.insert(d, { id = 2062, name = "Earth Elemental Totem", rank = "1", bCD = 1200000 } )
		table.insert(d, { id = 8042, name = "Earth Shock", rank = "1", bCD = 6000 } )
		table.insert(d, { id = 8044, name = "Earth Shock", rank = "2", bCD = 6000 } )
		table.insert(d, { id = 8045, name = "Earth Shock", rank = "3", bCD = 6000 } )
		table.insert(d, { id = 8046, name = "Earth Shock", rank = "4", bCD = 6000 } )
		table.insert(d, { id = 10412, name = "Earth Shock", rank = "5", bCD = 6000 } )
		table.insert(d, { id = 10413, name = "Earth Shock", rank = "6", bCD = 6000 } )
		table.insert(d, { id = 10414, name = "Earth Shock", rank = "7", bCD = 6000 } )
		table.insert(d, { id = 25454, name = "Earth Shock", rank = "8", bCD = 6000 } )
		table.insert(d, { id = 2484, name = "Earthbind Totem", rank = "", bCD = 15000 } )
		table.insert(d, { id = 2894, name = "Fire Elemental Totem", rank = "1", bCD = 1200000 } )
		table.insert(d, { id = 1535, name = "Fire Nova Totem", rank = "1", bCD = 15000 } )
		table.insert(d, { id = 8498, name = "Fire Nova Totem", rank = "2", bCD = 15000 } )
		table.insert(d, { id = 8499, name = "Fire Nova Totem", rank = "3", bCD = 15000 } )
		table.insert(d, { id = 11314, name = "Fire Nova Totem", rank = "4", bCD = 15000 } )
		table.insert(d, { id = 11315, name = "Fire Nova Totem", rank = "5", bCD = 15000 } )
		table.insert(d, { id = 25546, name = "Fire Nova Totem", rank = "6", bCD = 15000 } )
		table.insert(d, { id = 25547, name = "Fire Nova Totem", rank = "7", bCD = 15000 } )
		table.insert(d, { id = 8050, name = "Flame Shock", rank = "1", bCD = 6000 } )
		table.insert(d, { id = 8052, name = "Flame Shock", rank = "2", bCD = 6000 } )
		table.insert(d, { id = 8053, name = "Flame Shock", rank = "3", bCD = 6000 } )
		table.insert(d, { id = 10447, name = "Flame Shock", rank = "4", bCD = 6000 } )
		table.insert(d, { id = 10448, name = "Flame Shock", rank = "5", bCD = 6000 } )
		table.insert(d, { id = 29228, name = "Flame Shock", rank = "6", bCD = 6000 } )
		table.insert(d, { id = 25457, name = "Flame Shock", rank = "7", bCD = 6000 } )
		table.insert(d, { id = 8056, name = "Frost Shock", rank = "1", bCD = 6000 } )
		table.insert(d, { id = 8058, name = "Frost Shock", rank = "2", bCD = 6000 } )
		table.insert(d, { id = 10472, name = "Frost Shock", rank = "3", bCD = 6000 } )
		table.insert(d, { id = 10473, name = "Frost Shock", rank = "4", bCD = 6000 } )
		table.insert(d, { id = 25464, name = "Frost Shock", rank = "5", bCD = 6000 } )
		table.insert(d, { id = 8177, name = "Grounding Totem", rank = "", bCD = 15000 } )
		table.insert(d, { id = 32182, name = "Heroism", rank = "", bCD = 600000 } )
		table.insert(d, { id = 5730, name = "Stoneclaw Totem", rank = "1", bCD = 30000 } )
		table.insert(d, { id = 6390, name = "Stoneclaw Totem", rank = "2", bCD = 30000 } )
		table.insert(d, { id = 6391, name = "Stoneclaw Totem", rank = "3", bCD = 30000 } )
		table.insert(d, { id = 6392, name = "Stoneclaw Totem", rank = "4", bCD = 30000 } )
		table.insert(d, { id = 10427, name = "Stoneclaw Totem", rank = "5", bCD = 30000 } )
		table.insert(d, { id = 10428, name = "Stoneclaw Totem", rank = "6", bCD = 30000 } )
		table.insert(d, { id = 25525, name = "Stoneclaw Totem", rank = "7", bCD = 30000 } )
	
		-- TALENT SPELLS
		table.insert(d, { id = 16166, name = "Elemental Mastery", rank = "", bCD = 180000, oaf = true } )
		table.insert(d, { id = 16190, name = "Mana Tide Totem", rank = "", bCD = 300000 } )
		table.insert(d, { id = 16188, name = "Nature's Swiftness", rank = "", bCD = 180000, oaf = true } )
		table.insert(d, { id = 30823, name = "Shamanistic Rage", rank = "1", bCD = 120000 } )
		table.insert(d, { id = 17364, name = "Stormstrike", rank = "", bCD = 10000 } )

	end
	
	-- Warlock
	if class == "WARLOCK" then		
		-- MAIN SPELLS
		table.insert(d, { id = 603, name = "Curse of Doom", rank = "1", bCD = 60000 } )
		table.insert(d, { id = 30910, name = "Curse of Doom", rank = "2", bCD = 60000 } )
		table.insert(d, { id = 6789, name = "Death Coil", rank = "1", bCD = 120000 } )
		table.insert(d, { id = 17925, name = "Death Coil", rank = "2", bCD = 120000 } )
		table.insert(d, { id = 17926, name = "Death Coil", rank = "3", bCD = 120000 } )
		table.insert(d, { id = 27223, name = "Death Coil", rank = "4", bCD = 120000 } )
		table.insert(d, { id = 5484, name = "Howl of Terror", rank = "1", bCD = 40000 } )
		table.insert(d, { id = 17928, name = "Howl of Terror", rank = "2", bCD = 40000 } )
		table.insert(d, { id = 1122, name = "Inferno", rank = "", bCD = 3600000 } )
		table.insert(d, { id = 18540, name = "Ritual of Doom", rank = "", bCD = 3600000, oaf = true } )
		table.insert(d, { id = 29893, name = "Ritual of Souls", rank = "1", bCD = 300000, oaf = true } )
		table.insert(d, { id = 6229, name = "Shadow Ward", rank = "1", bCD = 30000 } )
		table.insert(d, { id = 11739, name = "Shadow Ward", rank = "2", bCD = 30000 } )
		table.insert(d, { id = 11740, name = "Shadow Ward", rank = "3", bCD = 30000 } )
		table.insert(d, { id = 28610, name = "Shadow Ward", rank = "4", bCD = 30000 } )
		table.insert(d, { id = 6353, name = "Soul Fire", rank = "1", bCD = 60000 } )
		table.insert(d, { id = 17924, name = "Soul Fire", rank = "2", bCD = 60000 } )
		table.insert(d, { id = 27211, name = "Soul Fire", rank = "3", bCD = 60000 } )
		table.insert(d, { id = 30545, name = "Soul Fire", rank = "4", bCD = 60000 } )
		table.insert(d, { id = 29858, name = "Soulshatter", rank = "", bCD = 300000 } )
	
		-- TALENT SPELLS
		table.insert(d, { id = 18288, name = "Amplify Curse", rank = "", bCD = 180000, oaf = true } )
		table.insert(d, { id = 17962, name = "Conflagrate", rank = "1", bCD = 10000 } )
		table.insert(d, { id = 18930, name = "Conflagrate", rank = "2", bCD = 10000 } )
		table.insert(d, { id = 18931, name = "Conflagrate", rank = "3", bCD = 10000 } )
		table.insert(d, { id = 18932, name = "Conflagrate", rank = "4", bCD = 10000 } )
		table.insert(d, { id = 27266, name = "Conflagrate", rank = "5", bCD = 10000 } )
		table.insert(d, { id = 30912, name = "Conflagrate", rank = "6", bCD = 10000 } )
		table.insert(d, { id = 18708, name = "Fel Domination", rank = "", bCD = 900000 } )
		table.insert(d, { id = 17877, name = "Shadowburn", rank = "1", bCD = 15000 } )
		table.insert(d, { id = 18867, name = "Shadowburn", rank = "2", bCD = 15000 } )
		table.insert(d, { id = 18868, name = "Shadowburn", rank = "3", bCD = 15000 } )
		table.insert(d, { id = 18869, name = "Shadowburn", rank = "4", bCD = 15000 } )
		table.insert(d, { id = 18870, name = "Shadowburn", rank = "5", bCD = 15000 } )
		table.insert(d, { id = 18871, name = "Shadowburn", rank = "6", bCD = 15000 } )
		table.insert(d, { id = 27263, name = "Shadowburn", rank = "7", bCD = 15000 } )
		table.insert(d, { id = 30546, name = "Shadowburn", rank = "8", bCD = 15000 } )
		table.insert(d, { id = 30283, name = "Shadowfury", rank = "1", bCD = 20000 } )
		table.insert(d, { id = 30413, name = "Shadowfury", rank = "2", bCD = 20000 } )
		table.insert(d, { id = 30414, name = "Shadowfury", rank = "3", bCD = 20000 } )

	end
	
	-- Warrior
	if class == "WARRIOR" then		
		-- MAIN SPELLS
		table.insert(d, { id = 2457, name = "Battle Stance", rank = "", bCD = 1000 } )
		table.insert(d, { id = 18499, name = "Berserker Rage", rank = "", bCD = 30000 } )
		table.insert(d, { id = 2458, name = "Berserker Stance", rank = "", bCD = 1000 } )
		table.insert(d, { id = 2687, name = "Bloodrage", rank = "", bCD = 60000 } )
		table.insert(d, { id = 1161, name = "Challenging Shout", rank = "", bCD = 600000 } )
		table.insert(d, { id = 100, name = "Charge", rank = "1", bCD = 15000 } )
		table.insert(d, { id = 6178, name = "Charge", rank = "2", bCD = 15000 } )
		table.insert(d, { id = 11578, name = "Charge", rank = "3", bCD = 15000 } )
		table.insert(d, { id = 71, name = "Defensive Stance", rank = "", bCD = 1000 } )
		table.insert(d, { id = 676, name = "Disarm", rank = "", bCD = 60000 } )
		table.insert(d, { id = 20252, name = "Intercept", rank = "1", bCD = 30000 } )
		table.insert(d, { id = 20616, name = "Intercept", rank = "2", bCD = 30000 } )
		table.insert(d, { id = 20617, name = "Intercept", rank = "3", bCD = 30000 } )
		table.insert(d, { id = 25272, name = "Intercept", rank = "4", bCD = 30000 } )
		table.insert(d, { id = 25275, name = "Intercept", rank = "5", bCD = 30000 } )
		table.insert(d, { id = 3411, name = "Intervene", rank = "", bCD = 30000 } )
		table.insert(d, { id = 5246, name = "Intimidating Shout", rank = "", bCD = 180000 } )
		table.insert(d, { id = 694, name = "Mocking Blow", rank = "1", bCD = 120000 } )
		table.insert(d, { id = 7400, name = "Mocking Blow", rank = "2", bCD = 120000 } )
		table.insert(d, { id = 7402, name = "Mocking Blow", rank = "3", bCD = 120000 } )
		table.insert(d, { id = 20559, name = "Mocking Blow", rank = "4", bCD = 120000 } )
		table.insert(d, { id = 20560, name = "Mocking Blow", rank = "5", bCD = 120000 } )
		table.insert(d, { id = 25266, name = "Mocking Blow", rank = "6", bCD = 120000 } )
		table.insert(d, { id = 7384, name = "Overpower", rank = "1", bCD = 5000 } )
		table.insert(d, { id = 7887, name = "Overpower", rank = "2", bCD = 5000 } )
		table.insert(d, { id = 11584, name = "Overpower", rank = "3", bCD = 5000 } )
		table.insert(d, { id = 11585, name = "Overpower", rank = "4", bCD = 5000 } )
		table.insert(d, { id = 6552, name = "Pummel", rank = "1", bCD = 10000 } )
		table.insert(d, { id = 6554, name = "Pummel", rank = "2", bCD = 10000 } )
		table.insert(d, { id = 1719, name = "Recklessness", rank = "", bCD = 1800000 } )
		table.insert(d, { id = 20230, name = "Retaliation", rank = "", bCD = 1800000 } )
		table.insert(d, { id = 6572, name = "Revenge", rank = "1", bCD = 5000 } )
		table.insert(d, { id = 6574, name = "Revenge", rank = "2", bCD = 5000 } )
		table.insert(d, { id = 7379, name = "Revenge", rank = "3", bCD = 5000 } )
		table.insert(d, { id = 11600, name = "Revenge", rank = "4", bCD = 5000 } )
		table.insert(d, { id = 11601, name = "Revenge", rank = "5", bCD = 5000 } )
		table.insert(d, { id = 25288, name = "Revenge", rank = "6", bCD = 5000 } )
		table.insert(d, { id = 25269, name = "Revenge", rank = "7", bCD = 5000 } )
		table.insert(d, { id = 30357, name = "Revenge", rank = "8", bCD = 5000 } )
		table.insert(d, { id = 72, name = "Shield Bash", rank = "1", bCD = 12000 } )
		table.insert(d, { id = 1671, name = "Shield Bash", rank = "2", bCD = 12000 } )
		table.insert(d, { id = 1672, name = "Shield Bash", rank = "3", bCD = 12000 } )
		table.insert(d, { id = 29704, name = "Shield Bash", rank = "4", bCD = 12000 } )
		table.insert(d, { id = 2565, name = "Shield Block", rank = "", bCD = 5000 } )
		table.insert(d, { id = 871, name = "Shield Wall", rank = "", bCD = 1800000 } )
		table.insert(d, { id = 23920, name = "Spell Reflection", rank = "", bCD = 10000 } )
		table.insert(d, { id = 355, name = "Taunt", rank = "", bCD = 10000 } )
		table.insert(d, { id = 6343, name = "Thunder Clap", rank = "1", bCD = 4000 } )
		table.insert(d, { id = 8198, name = "Thunder Clap", rank = "2", bCD = 4000 } )
		table.insert(d, { id = 8204, name = "Thunder Clap", rank = "3", bCD = 4000 } )
		table.insert(d, { id = 8205, name = "Thunder Clap", rank = "4", bCD = 4000 } )
		table.insert(d, { id = 11580, name = "Thunder Clap", rank = "5", bCD = 4000 } )
		table.insert(d, { id = 11581, name = "Thunder Clap", rank = "6", bCD = 4000 } )
		table.insert(d, { id = 25264, name = "Thunder Clap", rank = "7", bCD = 4000 } )
		table.insert(d, { id = 1680, name = "Whirlwind", rank = "", bCD = 10000 } )
	
		-- TALENT SPELLS
		table.insert(d, { id = 23881, name = "Bloodthirst", rank = "1", bCD = 6000 } )
		table.insert(d, { id = 23892, name = "Bloodthirst", rank = "2", bCD = 6000 } )
		table.insert(d, { id = 23893, name = "Bloodthirst", rank = "3", bCD = 6000 } )
		table.insert(d, { id = 23894, name = "Bloodthirst", rank = "4", bCD = 6000 } )
		table.insert(d, { id = 25251, name = "Bloodthirst", rank = "5", bCD = 6000 } )
		table.insert(d, { id = 30335, name = "Bloodthirst", rank = "6", bCD = 6000 } )
		table.insert(d, { id = 12809, name = "Concussion Blow", rank = "", bCD = 45000 } )
		table.insert(d, { id = 12292, name = "Death Wish", rank = "", bCD = 180000 } )
		table.insert(d, { id = 12975, name = "Last Stand", rank = "", bCD = 480000 } )
		table.insert(d, { id = 12294, name = "Mortal Strike", rank = "1", bCD = 6000 } )
		table.insert(d, { id = 21551, name = "Mortal Strike", rank = "2", bCD = 6000 } )
		table.insert(d, { id = 21552, name = "Mortal Strike", rank = "3", bCD = 6000 } )
		table.insert(d, { id = 21553, name = "Mortal Strike", rank = "4", bCD = 6000 } )
		table.insert(d, { id = 25248, name = "Mortal Strike", rank = "5", bCD = 6000 } )
		table.insert(d, { id = 30330, name = "Mortal Strike", rank = "6", bCD = 6000 } )
		table.insert(d, { id = 23922, name = "Shield Slam", rank = "1", bCD = 6000 } )
		table.insert(d, { id = 23923, name = "Shield Slam", rank = "2", bCD = 6000 } )
		table.insert(d, { id = 23924, name = "Shield Slam", rank = "3", bCD = 6000 } )
		table.insert(d, { id = 23925, name = "Shield Slam", rank = "4", bCD = 6000 } )
		table.insert(d, { id = 25258, name = "Shield Slam", rank = "5", bCD = 6000 } )
		table.insert(d, { id = 30356, name = "Shield Slam", rank = "6", bCD = 6000 } )
		table.insert(d, { id = 12328, name = "Sweeping Strikes", rank = "", bCD = 30000 } )

	end
	
	return d
end

-- PET SPELLS
private.GetPetData = function(class)
	local d = {}
	
	-- Hunter
	if class == "HUNTER" then
		table.insert(d, { id = 17253, name = "Bite", rank = "1", bCD = 10000 } )
		table.insert(d, { id = 17255, name = "Bite", rank = "2", bCD = 10000 } )
		table.insert(d, { id = 17256, name = "Bite", rank = "3", bCD = 10000 } )
		table.insert(d, { id = 17257, name = "Bite", rank = "4", bCD = 10000 } )
		table.insert(d, { id = 17258, name = "Bite", rank = "5", bCD = 10000 } )
		table.insert(d, { id = 17259, name = "Bite", rank = "6", bCD = 10000 } )
		table.insert(d, { id = 17260, name = "Bite", rank = "7", bCD = 10000 } )
		table.insert(d, { id = 17261, name = "Bite", rank = "8", bCD = 10000 } )
		table.insert(d, { id = 27050, name = "Bite", rank = "9", bCD = 10000 } )
		table.insert(d, { id = 7371, name = "Charge", rank = "1", bCD = 25000 } )
		table.insert(d, { id = 26177, name = "Charge", rank = "2", bCD = 25000 } )
		table.insert(d, { id = 26178, name = "Charge", rank = "3", bCD = 25000 } )
		table.insert(d, { id = 26179, name = "Charge", rank = "4", bCD = 25000 } )
		table.insert(d, { id = 26201, name = "Charge", rank = "5", bCD = 25000 } )
		table.insert(d, { id = 27685, name = "Charge", rank = "6", bCD = 25000 } )
		table.insert(d, { id = 1742, name = "Cower", rank = "1", bCD = 5000 } )
		table.insert(d, { id = 1753, name = "Cower", rank = "2", bCD = 5000 } )
		table.insert(d, { id = 1754, name = "Cower", rank = "3", bCD = 5000 } )
		table.insert(d, { id = 1755, name = "Cower", rank = "4", bCD = 5000 } )
		table.insert(d, { id = 1756, name = "Cower", rank = "5", bCD = 5000 } )
		table.insert(d, { id = 16697, name = "Cower", rank = "6", bCD = 5000 } )
		table.insert(d, { id = 27048, name = "Cower", rank = "7", bCD = 5000 } )
		table.insert(d, { id = 23099, name = "Dash", rank = "1", bCD = 30000 } )
		table.insert(d, { id = 23109, name = "Dash", rank = "2", bCD = 30000 } )
		table.insert(d, { id = 23110, name = "Dash", rank = "3", bCD = 30000 } )
		table.insert(d, { id = 23145, name = "Dive", rank = "1", bCD = 30000 } )
		table.insert(d, { id = 23147, name = "Dive", rank = "2", bCD = 30000 } )
		table.insert(d, { id = 23148, name = "Dive", rank = "3", bCD = 30000 } )
		table.insert(d, { id = 34889, name = "Fire Breath", rank = "1", bCD = 10000 } )
		table.insert(d, { id = 35323, name = "Fire Breath", rank = "2", bCD = 10000 } )
		table.insert(d, { id = 24604, name = "Furious Howl", rank = "1", bCD = 10000 } )
		table.insert(d, { id = 24605, name = "Furious Howl", rank = "2", bCD = 10000 } )
		table.insert(d, { id = 24603, name = "Furious Howl", rank = "3", bCD = 10000 } )
		table.insert(d, { id = 24597, name = "Furious Howl", rank = "4", bCD = 10000 } )
		table.insert(d, { id = 2649, name = "Growl", rank = "1", bCD = 5000 } )
		table.insert(d, { id = 14916, name = "Growl", rank = "2", bCD = 5000 } )
		table.insert(d, { id = 14917, name = "Growl", rank = "3", bCD = 5000 } )
		table.insert(d, { id = 14918, name = "Growl", rank = "4", bCD = 5000 } )
		table.insert(d, { id = 14919, name = "Growl", rank = "5", bCD = 5000 } )
		table.insert(d, { id = 14920, name = "Growl", rank = "6", bCD = 5000 } )
		table.insert(d, { id = 14921, name = "Growl", rank = "7", bCD = 5000 } )
		table.insert(d, { id = 27047, name = "Growl", rank = "8", bCD = 5000 } )
		table.insert(d, { id = 35387, name = "Poison Spit", rank = "1", bCD = 10000 } )
		table.insert(d, { id = 35389, name = "Poison Spit", rank = "2", bCD = 10000 } )
		table.insert(d, { id = 35392, name = "Poison Spit", rank = "3", bCD = 10000 } )
		table.insert(d, { id = 24450, name = "Prowl", rank = "1", bCD = 10000, oaf = true } )
		table.insert(d, { id = 24452, name = "Prowl", rank = "2", bCD = 10000, oaf = true } )
		table.insert(d, { id = 24453, name = "Prowl", rank = "3", bCD = 10000, oaf = true } )
		table.insert(d, { id = 24640, name = "Scorpid Poison", rank = "1", bCD = 4000 } )
		table.insert(d, { id = 24583, name = "Scorpid Poison", rank = "2", bCD = 4000 } )
		table.insert(d, { id = 24586, name = "Scorpid Poison", rank = "3", bCD = 4000 } )
		table.insert(d, { id = 24587, name = "Scorpid Poison", rank = "4", bCD = 4000 } )
		table.insert(d, { id = 27060, name = "Scorpid Poison", rank = "5", bCD = 4000 } )
		table.insert(d, { id = 26064, name = "Shell Shield", rank = "1", bCD = 180000 } )
		table.insert(d, { id = 26090, name = "Thunderstomp", rank = "1", bCD = 60000 } )
		table.insert(d, { id = 26187, name = "Thunderstomp", rank = "2", bCD = 60000 } )
		table.insert(d, { id = 26188, name = "Thunderstomp", rank = "3", bCD = 60000 } )
		table.insert(d, { id = 27063, name = "Thunderstomp", rank = "4", bCD = 60000 } )
		table.insert(d, { id = 35346, name = "Warp", rank = "", bCD = 15000 } )
	end
	
	-- Warlock
	if class == "WARLOCK" then
		table.insert(d, { id = 19505, name = "Devour Magic", rank = "1", bCD = 8000 } )
		table.insert(d, { id = 19731, name = "Devour Magic", rank = "2", bCD = 8000 } )
		table.insert(d, { id = 19734, name = "Devour Magic", rank = "3", bCD = 8000 } )
		table.insert(d, { id = 19736, name = "Devour Magic", rank = "4", bCD = 8000 } )
		table.insert(d, { id = 27276, name = "Devour Magic", rank = "5", bCD = 8000 } )
		table.insert(d, { id = 27277, name = "Devour Magic", rank = "6", bCD = 8000 } )
		table.insert(d, { id = 7814, name = "Lash of Pain", rank = "1", bCD = 12000 } )
		table.insert(d, { id = 7815, name = "Lash of Pain", rank = "2", bCD = 12000 } )
		table.insert(d, { id = 7816, name = "Lash of Pain", rank = "3", bCD = 12000 } )
		table.insert(d, { id = 11778, name = "Lash of Pain", rank = "4", bCD = 12000 } )
		table.insert(d, { id = 11779, name = "Lash of Pain", rank = "5", bCD = 12000 } )
		table.insert(d, { id = 11780, name = "Lash of Pain", rank = "6", bCD = 12000 } )
		table.insert(d, { id = 27274, name = "Lash of Pain", rank = "7", bCD = 12000 } )
		table.insert(d, { id = 4511, name = "Phase Shift", rank = "", bCD = 10000, oaf = true } )
		table.insert(d, { id = 6360, name = "Soothing Kiss", rank = "1", bCD = 4000 } )
		table.insert(d, { id = 7813, name = "Soothing Kiss", rank = "2", bCD = 4000 } )
		table.insert(d, { id = 11784, name = "Soothing Kiss", rank = "3", bCD = 4000 } )
		table.insert(d, { id = 11785, name = "Soothing Kiss", rank = "4", bCD = 4000 } )
		table.insert(d, { id = 27275, name = "Soothing Kiss", rank = "5", bCD = 4000 } )
		table.insert(d, { id = 19244, name = "Spell Lock", rank = "1", bCD = 24000 } )
		table.insert(d, { id = 19647, name = "Spell Lock", rank = "2", bCD = 24000 } )
		table.insert(d, { id = 17735, name = "Suffering", rank = "1", bCD = 120000 } )
		table.insert(d, { id = 17750, name = "Suffering", rank = "2", bCD = 120000 } )
		table.insert(d, { id = 17751, name = "Suffering", rank = "3", bCD = 120000 } )
		table.insert(d, { id = 17752, name = "Suffering", rank = "4", bCD = 120000 } )
		table.insert(d, { id = 27271, name = "Suffering", rank = "5", bCD = 120000 } )
		table.insert(d, { id = 33701, name = "Suffering", rank = "6", bCD = 120000 } )
		table.insert(d, { id = 3716, name = "Torment", rank = "1", bCD = 5000 } )
		table.insert(d, { id = 7809, name = "Torment", rank = "2", bCD = 5000 } )
		table.insert(d, { id = 7810, name = "Torment", rank = "3", bCD = 5000 } )
		table.insert(d, { id = 7811, name = "Torment", rank = "4", bCD = 5000 } )
		table.insert(d, { id = 11774, name = "Torment", rank = "5", bCD = 5000 } )
		table.insert(d, { id = 11775, name = "Torment", rank = "6", bCD = 5000 } )
		table.insert(d, { id = 27270, name = "Torment", rank = "7", bCD = 5000 } )
	end
	
	return d
end

-- The String for the custom text tag description
function CDTL2:GetCustomTextTagDescription()
	local text = ""
	
	text = text.."Currently custom tags are in the following format:\n\n"
	text = text.."    [p.hp.max]\n\n"
	text = text.."Currently supports the following categories:\n\n"
	text = text.."    'cdtl' - CDTL specfic\n"
	text = text.."    'p' - Player\n"
	text = text.."    'f' - Focus\n"
	text = text.."    't' - Target\n\n"
	text = text.."Supports the following sub types for CDTL:\n\n"
	text = text.."    '.name.n' - Name of next due CD\n"
	text = text.."    '.name.l' - Name of last due CD\n"
	text = text.."    '.name.nh' - Name of next due highlighted CD\n"
	text = text.."    '.name.lh' - Name of last due highlighted CD\n"
	text = text.."    '.time.n' - Time left of next due CD\n"
	text = text.."    '.time.l' - Time left of last due CD\n"
	text = text.."    '.time.nh' - Time left of next due highlighted CD\n"
	text = text.."    '.time.lh' - Time left of last due highlighted CD\n\n"
	text = text.."Supports the following sub types for non-CDTL:\n\n"
	text = text.."    '.name' - Unit name\n"
	text = text.."    '.class' - Unit class\n"
	text = text.."    '.level' - Unit level\n"
	text = text.."    '.hp.cur' - Current HP\n"
	text = text.."    '.hp.max' - Max HP\n"
	text = text.."    '.pow.cur' - Current power amount\n"
	text = text.."    '.pow.max' - Max power amount\n"
	
	return text
end

-- The String for the icon text tag description
function CDTL2:GetCustomIconTagDescription()
	local text = ""
	
	text = text.."Currently custom tags are in the following format:\n\n"
	text = text.."    [cd.name]\n\n"
	text = text.."Supports the following tags:\n\n"
	text = text.."    'cd.name' - Cooldown name\n"
	text = text.."    'cd.name.s' - Cooldown name in a short format\n"
	text = text.."    'cd.time' - Time remaining for the icon class\n"
	text = text.."    'cd.type' - Icon type (SPELL, ITEM, etc.)\n"
	text = text.."    'cd.stacks' - Stack count\n"
	
	--CDTL2:Print(text)
	return text
end

function CDTL2:ConvertTextTags(iString, frame)
	local oString = iString
			
	for _, tag in ipairs(private.customTextTags) do
		--CDTL2:Print("CHECKING: "..tostring(tag.name))
		
		if tostring(iString):find(tag["tag"]) then
			--local replacement = tag["func"]
			local replacement = tag["func"](frame)
		
			oString = string.gsub(oString, tag["tag"], replacement)
			--exportString = string.gsub(exportString, tag["tag"], tag.func(frame))
		end
	end
	
	return oString
end

-- Holds all the custom text tags
private.customTextTags = {
	-- CDTL --
	{	name = "Next CD Name",
		cat = "CDTL",
		desc = "Show the name of the next CD due",
		tag = "%[cdtl.name.n%]",
		func = function()
					local name = ""
					local lowestTime = 10000
					
					for _, cd in ipairs(CDTL2.cooldowns) do
						if cd.data["enabled"] == true then
							if cd.icon.valid == true or cd.bar.valid == true then
								if cd.data["currentCD"] > 0 then
									if cd.data["currentCD"] < lowestTime then
										name = cd.data["name"]
										lowestTime = cd.data["currentCD"]
									end
								end
							end
						end
					end
					
					return name
				end,
	},
	{	name = "Last CD Name",
		cat = "CDTL",
		desc = "Show the name of the last CD due",
		tag = "%[cdtl.name.l%]",
		func = function()
					local name = ""
					local lowestTime = 0
					
					for _, cd in ipairs(CDTL2.cooldowns) do
						if cd.data["enabled"] == true then
							if cd.icon.valid == true or cd.bar.valid == true then
								if cd.data["currentCD"] > 0 then
									if cd.data["currentCD"] > lowestTime then
										name = cd.data["name"]
										lowestTime = cd.data["currentCD"]
									end
								end
							end
						end
					end
					
					return name
				end,
	},
	{	name = "Next CD Time",
		cat = "CDTL",
		desc = "Show the time left of the next CD due",
		tag = "%[cdtl.time.n%]",
		func = function()
					local timeString = ""
					local lowestTime = 10000
					
					for _, cd in ipairs(CDTL2.cooldowns) do
						if cd.data["enabled"] == true then
							if cd.icon.valid == true or cd.bar.valid == true then
								if cd.data["currentCD"] > 0 then
									if cd.data["currentCD"] < lowestTime then
										timeString = CDTL2:GetReadableTime(cd.data["currentCD"])
										lowestTime = cd.data["currentCD"]
									end
								end
							end
						end
					end
					
					return timeString
				end,
	},
	{	name = "Last CD Time",
		cat = "CDTL",
		desc = "Show the time left of the last CD due",
		tag = "%[cdtl.time.l%]",
		func = function()
					local timeString = ""
					local lowestTime = 0
					
					for _, cd in ipairs(CDTL2.cooldowns) do
						if cd.data["enabled"] == true then
							if cd.icon.valid == true or cd.bar.valid == true then
								if cd.data["currentCD"] > 0 then
									if cd.data["currentCD"] > lowestTime then
										timeString = CDTL2:GetReadableTime(cd.data["currentCD"])
										lowestTime = cd.data["currentCD"]
									end
								end
							end
						end
					end
					
					return timeString
				end,
	},
	{	name = "Next Highlighted CD Name",
		cat = "CDTL",
		desc = "Show the name of the next highlighted CD due",
		tag = "%[cdtl.name.nh%]",
		func = function()
					local name = ""
					local lowestTime = 10000
					
					for _, cd in ipairs(CDTL2.cooldowns) do
						if cd.data["enabled"] == true then
							if cd.icon.valid == true or cd.bar.valid == true then
								if cd.data["highlighted"] == true then
									if cd.data["currentCD"] > 0 then
										if cd.data["currentCD"] < lowestTime then
											name = cd.data["name"]
											lowestTime = cd.data["currentCD"]
										end
									end
								end
							end
						end
					end
					
					return name
				end,
	},
	{	name = "Next Highlighted CD Name",
		cat = "CDTL",
		desc = "Show the name of the last highlighted CD due",
		tag = "%[cdtl.name.lh%]",
		func = function()
					local name = ""
					local lowestTime = 0
					
					for _, cd in ipairs(CDTL2.cooldowns) do
						if cd.data["enabled"] == true then
							if cd.icon.valid == true or cd.bar.valid == true then
								if cd.data["highlighted"] == true then
									if cd.data["currentCD"] > 0 then
										if cd.data["currentCD"] > lowestTime then
											name = cd.data["name"]
											lowestTime = cd.data["currentCD"]
										end
									end
								end
							end
						end
					end
					
					return name
				end,
	},
	{	name = "Next Highlighted CD Time",
		cat = "CDTL",
		desc = "Show the time left of the next highlighted CD due",
		tag = "%[cdtl.time.nh%]",
		func = function()
					local timeString = ""
					local lowestTime = 10000
					
					for _, cd in ipairs(CDTL2.cooldowns) do
						if cd.data["enabled"] == true then
							if cd.icon.valid == true or cd.bar.valid == true then
								if cd.data["highlighted"] == true then
									if cd.data["currentCD"] > 0 then
										if cd.data["currentCD"] < lowestTime then
											timeString = CDTL2:GetReadableTime(cd.data["currentCD"])
											lowestTime = cd.data["currentCD"]
										end
									end
								end
							end
						end
					end
					
					return timeString
				end,
	},
	{	name = "Last Highlighted CD Time",
		cat = "CDTL",
		desc = "Show the time left of the last highlighted CD due",
		tag = "%[cdtl.time.lh%]",
		func = function()
					local timeString = ""
					local lowestTime = 0
					
					for _, cd in ipairs(CDTL2.cooldowns) do
						if cd.data["enabled"] == true then
							if cd.icon.valid == true or cd.bar.valid == true then
								if cd.data["highlighted"] == true then
									if cd.data["currentCD"] > 0 then
										if cd.data["currentCD"] > lowestTime then
											timeString = CDTL2:GetReadableTime(cd.data["currentCD"])
											lowestTime = cd.data["currentCD"]
										end
									end
								end
							end
						end
					end
					
					return timeString
				end,
	},
	
	-- PLAYER --
	{	name = "Player Name",
		cat = "Player",
		desc = "Show the player name",
		tag = "%[p.name%]",
		func = function()
					return GetUnitName("player")
				end,
	},
	{	name = "Player Class",
		cat = "Player",
		desc = "Show the player class",
		tag = "%[p.class%]",
		func = function()
					local className, _, _ = UnitClass("player")
					return className
				end,
	},
	{	name = "Player Power Current",
		cat = "Player",
		desc = "Show the current amount of power used by the player",
		tag = "%[p.pow.cur%]",
		func = function()
					local className, _, _ = UnitClass("player")
					local powerType = CDTL2:GetPlayerPower(className)
						
					return UnitPower("player", powerType)
				end,
	},
	{	name = "Player Power Max",
		cat = "Player",
		desc = "Show the max amount of power used by player",
		tag = "%[p.pow.max%]",
		func = function()
					local className, _, _ = UnitClass("player")
					local powerType = CDTL2:GetPlayerPower(className)
						
					return UnitPowerMax("player", powerType)
				end,
	},
	{	name = "Player Level",
		cat = "Player",
		desc = "Show the player level",
		tag = "%[p.level%]",
		func = function()
					return UnitLevel("player")
				end,
	},
	{	name = "Player HP Current",
		cat = "Player",
		desc = "Show the current player HP",
		tag = "%[p.hp.cur%]",
		func = function()
					return UnitHealth("player")
				end,
	},
	{	name = "Player HP Max",
		cat = "Player",
		desc = "Show the max player HP",
		tag = "%[p.hp.max%]",
		func = function()
					return UnitHealthMax("player")
				end,
	},
	
	-- PET --
	
	
	-- FOCUS --
	{	name = "Focus Name",
		cat = "Focus",
		desc = "Show the name of your focus",
		tag = "%[f.name%]",
		func = function()
					if UnitExists("focus") then
						return GetUnitName("focus")
					end
					
					return ""
				end,
	},
	{	name = "Focus Class",
		cat = "Focus",
		desc = "Show the class of your focus",
		tag = "%[f.class%]",
		func = function()
					if UnitExists("focus") then
						local className, _, _ = UnitClass("focus")
						return className
					end
					
					return ""
				end,
	},
	{	name = "Focus Power Current",
		cat = "Focus",
		desc = "Show the current amount of power used by the class of your focus",
		tag = "%[f.pow.cur%]",
		func = function()
					if UnitExists("focus") then
						local className, _, _ = UnitClass("focus")
						local powerType = CDTL2:GetPlayerPower(className)
						
						return UnitPower("focus", powerType)
					end
					
					return ""
				end,
	},
	{	name = "Focus Power Max",
		cat = "Focus",
		desc = "Show the max amount of power used by the class of your focus",
		tag = "%[f.pow.max%]",
		func = function()
					if UnitExists("focus") then
						local className, _, _ = UnitClass("focus")
						local powerType = CDTL2:GetPlayerPower(className)
						
						return UnitPowerMax("focus", powerType)
					end
					
					return ""
				end,
	},
	{	name = "Focus Level",
		cat = "Focus",
		desc = "Show the level of your focus",
		tag = "%[f.level%]",
		func = function()
					if UnitExists("focus") then
						return UnitLevel("focus")
					end
					
					return ""
				end,
	},
	{	name = "Focus HP Current",
		cat = "Focus",
		desc = "Show the current HP of your focus",
		tag = "%[f.hp.cur%]",
		func = function()
					if UnitExists("focus") then
						return UnitHealth("focus")
					end
					
					return ""
				end,
	},
	{	name = "Focus HP Max",
		cat = "Focus",
		desc = "Show the max HP of your focus",
		tag = "%[f.hp.max%]",
		func = function()
					if UnitExists("focus") then
						return UnitHealthMax("focus")
					end
					
					return ""
				end,
	},
	
	-- TARGET --
	{	name = "Target Name",
		cat = "Target",
		desc = "Show the name of your target",
		tag = "%[t.name%]",
		func = function()
					if UnitExists("target") then
						return GetUnitName("target")
					end
					
					return ""
				end,
	},
	{	name = "Target Class",
		cat = "Target",
		desc = "Show the class of your target",
		tag = "%[t.class%]",
		func = function()
					if UnitExists("target") then
						local className, _, _ = UnitClass("target")
						return className
					end
					
					return ""
				end,
	},
	{	name = "Target Power Current",
		cat = "Target",
		desc = "Show the current amount of power used by the class of your target",
		tag = "%[t.pow.cur%]",
		func = function()
					if UnitExists("target") then
						local className, _, _ = UnitClass("target")
						local powerType = CDTL2:GetPlayerPower(className)
						
						return UnitPower("target", powerType)
					end
					
					return ""
				end,
	},
	{	name = "Target Power Max",
		cat = "Target",
		desc = "Show the max amount of power used by the class of your target",
		tag = "%[t.pow.max%]",
		func = function()
					if UnitExists("target") then
						local className, _, _ = UnitClass("target")
						local powerType = CDTL2:GetPlayerPower(className)
						
						return UnitPowerMax("target", powerType)
					end
					
					return ""
				end,
	},
	{	name = "Target Level",
		cat = "Target",
		desc = "Show the level of your target",
		tag = "%[t.level%]",
		func = function()
					if UnitExists("target") then
						return UnitLevel("target")
					end
					
					return ""
				end,
	},
	{	name = "Target HP Current",
		cat = "Target",
		desc = "Show the current HP of your target",
		tag = "%[t.hp.cur%]",
		func = function()
					if UnitExists("target") then
						return UnitHealth("target")
					end
					
					return ""
				end,
	},
	{	name = "Target HP Max",
		cat = "Target",
		desc = "Show the max HP of your target",
		tag = "%[t.hp.max%]",
		func = function()
					if UnitExists("target") then
						return UnitHealthMax("target")
					end
					
					return ""
				end,
	},

	-- CURRENT --
	{	name = "Cooldown Name",
		cat = "CD",
		desc = "Show the name of this CD",
		tag = "%[cd.name%]",
		func = function(frame)
					if frame then
						return frame.data["name"]
					end
					
					return "Error"
				end,
	},
	{	name = "Cooldown Name (Short)",
		cat = "CD",
		desc = "Show the abbreviated name of this CD",
		tag = "%[cd.name.s%]",
		func = function(frame)
					if frame then
						local name = ""
						local words = frame.data["name"]:gmatch("%S+")
						
						for w in words do
							name = name..w:sub(1, 1)
						end
						
						return name
					end
					
					return "Error"
				end,
	},
	{	name = "Cooldown Time",
		cat = "CD",
		desc = "Show the name of this CD",
		tag = "%[cd.time%]",
		func = function(frame)
					if frame then
						return tostring(CDTL2:GetReadableTime(frame.data["currentCD"]))
					end
					
					return "Error"
				end,
	},
	{	name = "Cooldown Type",
		cat = "CD",
		desc = "Show the name of this CD",
		tag = "%[cd.type%]",
		func = function(frame)
					if frame then
						return frame.data["type"]
					end
					
					return "Error"
				end,
	},
	{	name = "Cooldown Stacks",
		cat = "CD",
		desc = "Show the number of stacks of this CD",
		tag = "%[cd.stacks%]",
		func = function(frame)
					if frame then
						if frame.data["stacks"] == 0 then
							return ""
						else
							return frame.data["stacks"]
						end
					end
					
					return "Error"
				end,
	},
	
	-- TESTING --
	{	name = "Icon Stack",
		cat = "CD",
		desc = "Show the stack number of this icon",
		tag = "%[cd.iconstack%]",
		func = function(frame)
					if frame then
						if frame.icon.stack then
							return frame.icon.stack
						else
							return ""
						end
					end
					
					return "Error"
				end,
	},
}