local private = {}

function CDTL2:AddUsedBy(type, id, guid)
	for _, data in pairs(CDTL2.db.profile.tables[type]) do
		if data["id"] == id then
			table.insert(data["usedBy"], guid)
		end
	end
end

function CDTL2:AuraExists(unit, aura)
	for i = 1, 40, 1 do
		local name, icon, count, debuffType, duration, expirationTime, unitCaster, isStealable, shouldConsolidate, spellId = UnitAura(unit, i, "HELPFUL")
		
		if name then
			if aura == name then
				--CDTL2:Print("MATCH - "..name.." - "..icon.." - "..tostring(count).." - "..tostring(debuffType).." - "..duration.." - "..expirationTime)
				local s = {
					id = spellId,
					bCD = duration * 1000,
					name = name,
					type = "buffs",
					icon = icon,
					stacks = count,
					endTime = expirationTime,
				}
				
				return s
			end
		end
	end
	
	for i = 1, 40, 1 do
		local name, icon, count, debuffType, duration, expirationTime, unitCaster, isStealable, shouldConsolidate, spellId = UnitAura(unit, i, "HARMFUL")
		
		if name then
			if aura == name then
				--CDTL2:Print("MATCH - "..name.." - "..icon.." - "..tostring(count).." - "..tostring(debuffType).." - "..duration.." - "..expirationTime)
				--Dark Iron Pipeweed - 134374 - 0 - nil - 20 - 3553296.12 - player 
				local s = {
					id = spellId,
					bCD = duration * 1000,
					name = name,
					type = "buffs",
					icon = icon,
					stacks = count,
					endTime = expirationTime,
				}
				
				return s
			end
		end
	end
	
	return nil
end

function CDTL2:Autohide(f)
	if CDTL2.db.profile.global["autohide"] and not CDTL2.db.profile.global["unlockFrames"] and not CDTL2.db.profile.global["debugMode"] then
		if f.childCount == 0 then
			if f:GetAlpha() ~= 0 then
				f:SetAlpha(0)
			end
		else
			if f:GetAlpha() ~= 1 then
				f:SetAlpha(1)
			end
		end
	else
		if f:GetAlpha() ~= 1 then
			f:SetAlpha(1)
		end
	end
end

function CDTL2:GetCharacterData()
	if CDTL2.player["class"] == nil then
		local playerGUID = UnitGUID("player")
		local _, engClass, _, engRace, gender, name, server = GetPlayerInfoByGUID(playerGUID)
		
		if engClass ~= nil then
			CDTL2.player = {
				guid = playerGUID,
				name = name,
				race = engRace,
				class = engClass,
				classPower = CDTL2:GetPlayerPower(engClass),
			}
		
			CDTL2.spellData = CDTL2:GetAllSpellData(engClass, engRace)
			
			if CDTL2.db.profile.global["debugMode"] then
				CDTL2:Print("PLAYER: "..CDTL2.player["name"].." - "..CDTL2.player["race"].." - "..CDTL2.player["class"])
			end
		end
	end
end

function CDTL2:GetPlayerPower(class)
	if class == "Rogue" then
		return Enum.PowerType.Energy
	elseif class == "Warrior" then
		return Enum.PowerType.Rage
	elseif class == "Druid" then
		local form = GetShapeshiftForm()
		if form == 1 then
			return Enum.PowerType.Rage
		elseif form == 3 then
			return Enum.PowerType.Energy
		else
			return Enum.PowerType.Mana
		end
	else
		return Enum.PowerType.Mana
	end
end

function CDTL2:GetItemSpell(id)
	-- EQUIPPED ITEMS
	for i = 0, 23, 1 do
		local itemId = GetInventoryItemID("player", i)
		local spellName, spellID = GetItemSpell(itemId)
		--local itemName, _, itemQuality, itemLevel, _, itemType, itemSubType, _, _, itemTexture, sellPrice, _, _, _, _, _, _ = GetItemInfo(itemId) 
		--CDTL2:Print("ITEM-SCANNING: "..tostring(i).." - "..tostring(spellID))
		
		if spellID == id then
			--CDTL2:Print("FOUND-EQUIPPED: "..itemId.." - ")
			local s = {}
				s["name"] = spellName
				s["id"] = spellID
				s["bCD"] = 0
				s["itemID"] = itemId
				s["lane"] = CDTL2.db.profile.global["items"]["defaultLane"]
				s["barFrame"] = CDTL2.db.profile.global["items"]["defaultBar"]
				s["readyFrame"] = CDTL2.db.profile.global["items"]["defaultReady"]
				s["enabled"] = CDTL2.db.profile.global["items"]["showByDefault"]
				s["highlight"] = false
				s["pinned"] = false
				
			local item = Item:CreateFromItemID(itemId)
			item:ContinueOnItemLoad(function()
				s["itemName"] = item:GetItemName()
				s["icon"] = item:GetItemIcon()
				s["link"] = item:GetItemLink()
			end)

			return s
		end
	end
	
	-- INVENTORY
	for i = 0, 4, 1 do
		local numberOfSlots = GetContainerNumSlots(0)
		for x = 0, numberOfSlots, 1 do
			local itemId = GetContainerItemID(i, x)
			local spellName, spellID = GetItemSpell(itemId)
			--local itemName, _, itemQuality, itemLevel, _, itemType, itemSubType, _, _, itemTexture, sellPrice, _, _, _, _, _, _ = GetItemInfo(itemId) 
			--CDTL2:Print("ITEM-SCANNING: "..tostring(i).."."..tostring(x).." - "..tostring(spellID))
			
			if spellID == id then
				--CDTL2:Print("FOUND-INVENTORY: "..itemId.." - ")
				local s = {}
					s["name"] = spellName
					s["id"] = spellID
					s["bCD"] = 0
					--s["itemName"] = ""
					s["itemID"] = itemId
					--s["icon"] = icon
					s["lane"] = 1
					s["barFrame"] = 1
					s["readyFrame"] = 1
					
					s["enabled"] = true
					s["highlight"] = false
					s["pinned"] = false
					
				local item = Item:CreateFromItemID(itemId)
				item:ContinueOnItemLoad(function()
					s["itemName"] = item:GetItemName()
					s["icon"] = item:GetItemIcon()
					s["link"] = item:GetItemLink()
				end)
				
				return s
			end
			
		end
	end
	
	return nil
end

function CDTL2:GetPlayerPower(class)
	if class == "Rogue" then
		return Enum.PowerType.Energy
	elseif class == "Warrior" then
		return Enum.PowerType.Rage
	elseif class == "Druid" then
		local form = GetShapeshiftForm()
		if form == 1 then
			return Enum.PowerType.Rage
		elseif form == 3 then
			return Enum.PowerType.Energy
		else
			return Enum.PowerType.Mana
		end
	else
		return Enum.PowerType.Mana
	end
end

function CDTL2:GetReadableTime(t)
	local readableTimeLeft = t

	if t > 60 then
		readableTimeLeft = math.floor(t*math.pow(10,0)+0.5) / math.pow(10,0)
		
		local minutes = tostring(math.floor(readableTimeLeft / 60))
		local seconds = readableTimeLeft % 60
		
		if seconds >= 10 then
			seconds = tostring(seconds)
		elseif seconds > 0 then
			seconds = tostring("0"..seconds)
		else
			seconds = "00"
		end
		
		readableTimeLeft = minutes..":"..seconds
		
	elseif t > 10 then
		readableTimeLeft = tonumber(string.format("%.0f", readableTimeLeft))
	else
		readableTimeLeft = tonumber(string.format("%.1f", readableTimeLeft))
		if readableTimeLeft == math.floor(readableTimeLeft) then
			readableTimeLeft = readableTimeLeft..".0"
		end
	end
	
	return readableTimeLeft
end

function CDTL2:GetShortTime(t)
	local readableTimeLeft = t
	
	if t >= 60 then
		local minutes = tostring(math.floor(t / 60))
		local seconds = readableTimeLeft % 60
		
		readableTimeLeft = minutes.."m"
		
		if seconds ~= 0 then
			readableTimeLeft = readableTimeLeft..seconds.."s"
		end
	else
		readableTimeLeft = tonumber(string.format("%.0f", readableTimeLeft)).."s"
	end
	
	return readableTimeLeft
end

function CDTL2:GetExistingCooldown(name, type, targetID)
	for _, e in pairs(CDTL2.cooldowns) do
		--CDTL2:Print(e.data["name"].." - "..name)
		if e.data["name"] == name and e.data["type"] == type then
			if targetID then
				if targetID == e.data["targetID"] then
					return e
				end
			else
				return e
			end
		end
	end
	
	return nil
end

function CDTL2:GetSpellSettings(name, type, id)
	for _, e in pairs(CDTL2.db.profile.tables[type]) do
		if id then
			if e["id"] == id then
				return e
			end
		else
			if e["name"] == name then
				return e
			end
		end
	end
	
	return nil
end

function CDTL2:GetSpellName(id)
	for _, spell in pairs(CDTL2.spellData) do
		if spell["id"] == id then
			return spell["name"]
		end
	end
	
	return nil
end

function CDTL2:GetUID()
	CDTL2.cdUID = CDTL2.cdUID + 1
	return CDTL2.cdUID
end

function CDTL2:GetValidChildren(f)
	local children = { f:GetChildren() }
	local validChildren = {}
	
	local count = 0
	for _, child in ipairs(children) do
		if child.uid then
			count = count + 1
			table.insert(validChildren, child)
		end
	end
	
	return validChildren
end

function CDTL2:IsUsedBy(type, id)
	if CDTL2.player["class"] == nil then
		CDTL2:GetCharacterData()
	end

	for _, spell in pairs(CDTL2.db.profile.tables[type]) do
		if spell["id"] == id then
			for _, data in pairs(spell["usedBy"]) do
				if CDTL2.player["guid"] == data then
					return true
				end
			end
		end
	end
	
	return false
end

function CDTL2:IsValidItem(itemID)
	local _, itemType, itemSubType, _, _, classID, subclassID = GetItemInfoInstant(itemID)
	
	if CDTL2.db.profile.global["debugMode"] then
		CDTL2:Print("ITEM: "..itemType.." - "..itemSubType)
	end
	
	-- CONSUMABLE
	if classID == 0 then
		if
			subclassID == 0 or	-- Generic
			subclassID == 1 or	-- Potion
			subclassID == 2 	-- Elixir
		then
			return true
		end
	end
	
	-- WEAPON
	if classID == 2 then
		return true
	end
	
	-- ARMOR
	if classID == 4 then
		return true
	end
	
	-- QUEST
	if classID == 12 then
		return true
	end
	
	-- MISCELLANEOUS
	if classID == 15 then
		if
			subclassID == 4		-- Other
		then
			return true
		end
	end
	
	return false
end

function CDTL2:LoadFilterList(type)
	local list = {}
	
	for _, data in pairs(CDTL2.db.profile.tables[type]) do
		
		for _, guid in pairs(data["usedBy"]) do
			if CDTL2:IsUsedBy(type, data["id"]) then
				list[data["name"]] = data["name"]
			end
		end
	end
	
	return list
end

function CDTL2:RecycleOffensiveCD()
	for k, child in ipairs(CDTL2.cooldowns) do
		if child.data["type"] == "offensives" then
			if child.data["currentCD"] < 0 then
				return child
			end
		end
	end
	
	return nil
end

function CDTL2:RefreshConfig()	
	for k, f in pairs(CDTL2.readyFrames) do
		CDTL2:RefreshReady(k)
	end
	
	for k, f in pairs(CDTL2.lanes) do
		CDTL2:RefreshLane(k)
	end
	
	for _, f in pairs(CDTL2.cooldowns) do
		CDTL2:RefreshBar(f.bar)
		CDTL2:RefreshIcon(f.icon)
	end
end

function CDTL2:ScanCurrentCooldowns(class, race)
	local sd = CDTL2:GetAllSpellData(class, race)

	-- SPELLS
	for _, spell in pairs(sd) do
		--CDTL2:Print("SCANNING: "..spell["id"].." - "..spell["name"])
		local start, duration, enabled, _ = GetSpellCooldown(spell["id"])
		
		if duration > 1.5 then
			if CDTL2:GetExistingCooldown(spell["name"], "spells") then
				--CDTL2:Print("    EXISTING FOUND: "..spell["id"].." - "..spell["name"])
			else
				local s = CDTL2:GetSpellSettings(spell["name"], "spells")
				if s then
					CDTL2:CreateCooldown(CDTL2:GetUID(),"spells" , s)
					
					if not CDTL2:IsUsedBy("spells", spellID) then
						CDTL2:AddUsedBy("spells", spellID, CDTL2.player["guid"])
					end
				else
					local _, _, icon, _, _, _, _ = GetSpellInfo(spell["id"])
					
					local s = {
						id = spell["id"],
						bCD = duration,
						name = spell["name"],
						type = "spells",
						icon = icon,
						
						lane = 1,
						barFrame = 1,
						readyFrame = 1,
						
						usedBy = { CDTL2.player["guid"] },
					}
					
					table.insert(CDTL2.db.profile.tables["spells"], s)
					
					CDTL2:CreateCooldown(CDTL2:GetUID(),"spells" , s)
				end
			end
		end
	end
	
	-- ITEMS EQUIPPED
	for i = 0, 23, 1 do
		local itemId = GetInventoryItemID("player", i)
		local spellName, spellID = GetItemSpell(itemId)
		
		if spellName then
			--CDTL2:Print("SCANNING: "..itemId.." - "..spellID.." - "..spellName)
		
		--if CDTL2:IsValidItem(itemID) then
			local start, duration, enabled = GetItemCooldown(itemId)
			
			if duration > 1.5 then
				--CDTL2:Print("COOLINGDOWN: "..itemId.." - "..spellID.." - "..spellName)
				
				if CDTL2:GetExistingCooldown(spellName, "items") then
					--CDTL2:Print("    EXISTING FOUND: "..spell["id"].." - "..spell["name"])
				else
					local s = CDTL2:GetSpellSettings(spellName, "items")
					if s then
						--CDTL2:Print("    CREATING NEW: "..spell["id"].." - "..spell["name"])
						CDTL2:CreateCooldown(CDTL2:GetUID(),"items" , s)
						
						if not CDTL2:IsUsedBy("items", spellID) then
							CDTL2:AddUsedBy("items", spellID, CDTL2.player["guid"])
						end
					else
						s = {}
							s["name"] = spellName
							s["id"] = spellID
							s["bCD"] = duration * 1000
							s["itemID"] = itemId
							s["lane"] = 1
							s["barFrame"] = 1
							s["usedBy"] = { CDTL2.player["guid"] }
							
						local item = Item:CreateFromItemID(itemId)
						item:ContinueOnItemLoad(function()
							--local name = item:GetItemName() 
							--local icon = item:GetItemIcon()
							
							s["itemName"] = item:GetItemName()
							s["icon"] = item:GetItemIcon()
							s["link"] = item:GetItemLink()
							
							--print(name, icon) -- "Red Winter Hat", 133169
						end)
					
						--CDTL2:Print("ADDING: "..s["id"].." - "..s["name"])
						table.insert(CDTL2.db.profile.tables["items"], s)
						
						CDTL2:CreateCooldown(CDTL2:GetUID(),"items" , s)
					end
				end
			end
		end
	end
	
	-- ITEMS BAGS
	for i = 0, 4, 1 do
		local numberOfSlots = GetContainerNumSlots(0)
		for x = 0, numberOfSlots, 1 do
			local itemId = GetContainerItemID(i, x)
			local spellName, spellID = GetItemSpell(itemId)
			
			if spellName then
				--CDTL2:Print("SCANNING: "..itemId.." - "..spellID.." - "..spellName)
			
			--if CDTL2:IsValidItem(itemID) then
				local start, duration, enabled = GetItemCooldown(itemId)
				
				if duration > 1.5 then
					--CDTL2:Print("COOLINGDOWN: "..itemId.." - "..spellID.." - "..spellName)
					
					if CDTL2:GetExistingCooldown(spellName, "items") then
						--CDTL2:Print("    EXISTING FOUND: "..spell["id"].." - "..spell["name"])
					else
						local s = CDTL2:GetSpellSettings(spellName, "items")
						if s then
							--CDTL2:Print("    CREATING NEW: "..spell["id"].." - "..spell["name"])
							CDTL2:CreateCooldown(CDTL2:GetUID(),"items" , s)
							
							if not CDTL2:IsUsedBy("items", spellID) then
								CDTL2:AddUsedBy("items", spellID, CDTL2.player["guid"])
							end
						else
							s = {}
								s["name"] = spellName
								s["id"] = spellID
								s["bCD"] = duration * 1000
								s["itemID"] = itemId
								s["lane"] = 1
								s["barFrame"] = 1
								s["usedBy"] = { CDTL2.player["guid"] }
								
							local item = Item:CreateFromItemID(itemId)
							item:ContinueOnItemLoad(function()
								--local name = item:GetItemName() 
								--local icon = item:GetItemIcon()
								
								s["itemName"] = item:GetItemName()
								s["icon"] = item:GetItemIcon()
								s["link"] = item:GetItemLink()
								
								--print(name, icon) -- "Red Winter Hat", 133169
							end)
						
							--CDTL2:Print("ADDING: "..s["id"].." - "..s["name"])
							table.insert(CDTL2.db.profile.tables["items"], s)
							
							CDTL2:CreateCooldown(CDTL2:GetUID(),"items" , s)
						end
					end
				end
			end
		end
	end
end

function CDTL2:SetBorder(f, s)
	local inset = s["inset"]
	local padding = s["padding"]

	f:SetBackdrop({
		bgFile = CDTL2.LSM:Fetch("background", "None"),
		edgeFile = CDTL2.LSM:Fetch("border", s["style"]),
		tile = false,
		tileSize = 0,
		edgeSize = s["size"],
		insets = { left = inset, right = inset, top = inset, bottom = inset }
	})
	f:SetBackdropBorderColor(
		s["color"]["r"],
		s["color"]["g"],
		s["color"]["b"],
		s["color"]["a"]
	)
	f:SetPoint("TOPLEFT", f:GetParent(), "TOPLEFT", -padding, padding)
	f:SetPoint("BOTTOMRIGHT", f:GetParent(), "BOTTOMRIGHT", padding, -padding)
end

function CDTL2:SetSpellData(name, type, k, v)
	for _, e in pairs(CDTL2.db.profile.tables[type]) do
		if e["name"] == name then
			e[k] = v
		end
	end
end

function CDTL2:ToggleDebug()
	local debugMode = CDTL2.db.profile.global["debugMode"]
	
	if debugMode then
		CDTL2.db.profile.global["debugMode"] = false
		CDTL2.debugFrame:Hide()
		
		for _, f in pairs(CDTL2.holders) do
			f:SetAlpha(0)
		end
		
		for _, f in pairs(CDTL2.lanes) do
			private.DebugOff(f)
		end
		
		for _, f in pairs(CDTL2.barFrames) do
			private.DebugOff(f)
		end
		
		for _, f in pairs(CDTL2.readyFrames) do
			private.DebugOff(f)
		end
		
		for _, f in pairs(CDTL2.cooldowns) do
			private.DebugOff(f.bar)
			private.DebugOff(f.icon)
		end
		
		CDTL2:Print("Debug Mode Disabled")
	else
		CDTL2.db.profile.global["debugMode"] = true
		CDTL2.debugFrame:Show()
		
		for _, f in pairs(CDTL2.holders) do
			f:SetAlpha(1)
		end
		
		for _, f in pairs(CDTL2.lanes) do
			private.DebugOn(f)
		end
		
		for _, f in pairs(CDTL2.barFrames) do
			private.DebugOn(f)
		end
		
		for _, f in pairs(CDTL2.readyFrames) do
			private.DebugOn(f)
		end
		
		for _, f in pairs(CDTL2.cooldowns) do
			private.DebugOff(f.bar)
			private.DebugOff(f.icon)
		end
		
		CDTL2:Print("Debug Mode Enabled")
	end
end

function CDTL2:ToggleFrameLock()
	local unlockFrames = CDTL2.db.profile.global["unlockFrames"]
	
	if unlockFrames then
		CDTL2.db.profile.global["unlockFrames"] = false
		CDTL2.unlockFrame:Hide()

		for _, f in pairs(CDTL2.lanes) do
			private.FrameLock(f)
		end
		
		for _, f in pairs(CDTL2.barFrames) do
			private.FrameLock(f)
		end
		
		for _, f in pairs(CDTL2.readyFrames) do
			private.FrameLock(f)
		end
		
		CDTL2:Print("Frames Locked")
	else
		CDTL2.db.profile.global["unlockFrames"] = true
		CDTL2.unlockFrame:Show()
		
		for _, f in pairs(CDTL2.lanes) do
			private.FrameUnlock(f)
		end
		
		for _, f in pairs(CDTL2.barFrames) do
			private.FrameUnlock(f)
		end
		
		for _, f in pairs(CDTL2.readyFrames) do
			private.FrameUnlock(f)
		end
		
		CDTL2:Print("Frames Unlocked")
	end
end

function CDTL2:FrameLock(f)
	private.FrameLock(f)
end

function CDTL2:FrameUnlock(f)
	private.FrameUnlock(f)
end

function CDTL2:DebugOn(f)
	private.DebugOn(f)
end

function CDTL2:DebugOff(f)
	private.DebugOff(f)
end

private.DebugOff = function(f)	
	f.db:Hide()
	
	if CDTL2.db.profile.global["unlockFrames"] then
		private.FrameUnlock(f)
	end
end

private.DebugOn = function(f)
	f.db.text:SetText(f:GetName())
	f.db:Show()
end

private.FrameLock = function(f)
	f:SetMovable(false)
	f:EnableMouse(false)
	
	f.db.text:SetText(f.name)
	
	f.db:Hide()
	
	if CDTL2.db.profile.global["debugMode"] then
		private.DebugOn(f)
	end
end

private.FrameUnlock = function(f)
	f:SetMovable(true)
	f:EnableMouse(true)
	
	f.db.text:SetText(f.name)

	f.db:Show()
end